/*
 * Created on 10.03.2004
 */
package org.n52.wmsclientcore;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.ValidationException;
import org.n52.wmsclientcore.context.Format;
import org.n52.wmsclientcore.context.FormatList;
import org.n52.wmsclientcore.context.LayerList;


/**
 * @author Theodor
 */
public class ContextStreamingServlet extends HttpServlet {

	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		HttpSession session = req.getSession();
		ClientModelController controller = (ClientModelController)session.getAttribute("controller");
		Format format = new Format();
		format.setContent("image/png");
		format.setCurrent(true);
		FormatList formatList = new FormatList();
		formatList.addFormat(format);
		LayerList layerList = controller.getContext().getLayerList();
		for(int i = 0; i < layerList.getLayerCount(); i++)
			layerList.getLayer(i).setFormatList(formatList);
		
		res.setContentType("text/xml");	
		
		res.setHeader("Content-Disposition", 
								  "attachment; filename=MyContext.cml");
		
		PrintWriter out = res.getWriter();
		try {
			controller.getContext().marshal(out);
		} catch (MarshalException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ValidationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
}
