package org.n52.wmsclientcore;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;

import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;

import org.apache.log4j.Logger;

/**
 * Created by IntelliJ IDEA.
 * User: senkler
 * Date: 23.07.2003
 * Time: 11:27:12
 * To change this template use Options | File Templates.
 */
public class ImageBuilder {

    private static Logger logger = Logger.getLogger(ImageBuilder.class.getName());

    String requestUrl;
    PlanarImage image = null;

    public ImageBuilder() {

    }

    public void doRequest(String requestUrl) throws WmsException {
        this.requestUrl = requestUrl;

        try {
            this.image = JAI.create("url", new URL(this.requestUrl));

            // test, if its an image, this is only a workaround...!!!
            image.getWidth();
        } catch (MalformedURLException e) {
            e.printStackTrace();
        }  catch (Exception e) {
           // String errorMessage = getRemoteServiceException();
            //logger.error(errorMessage);
            throw new WmsException("Service exception while accessing " + this.requestUrl + ":\n");
            
        }
    }

    public PlanarImage getImage() {
        return image;
    }

    private String getRemoteServiceException() {
        try {
            URL url = new URL(this.requestUrl);
            InputStream is = url.openStream();
            BufferedReader reader = new BufferedReader(new InputStreamReader(is));
            StringBuffer sb = new StringBuffer();
            String line = reader.readLine();
            while (line!= null) {
                sb.append(line);
                line = reader.readLine();
            }
            return sb.toString();
        } catch (MalformedURLException e) {
            logger.error(e);
        } 
        catch(IOException e) {
            logger.error(e);
        }
        return null;
    }
}
