/*
 * Created on 24.01.2004
 */
package org.n52.wmsclientcore;

import org.apache.commons.collections.map.LRUMap;

/**
 * Dies ist eine Klasse, die nach dem Singletonpattern aufgebaut ist. Es bietet an Objekte zu cachen.
 * @author Theodor
 */
public abstract class ObjectCache {
	public static LRUMap instance;
	private static boolean cachingEnabled;
	public static LRUMap getInstance()
	{
		init();
		return instance;
	}
	private static void init()
	{
		if(instance== null)
			instance = new LRUMap(10);
	}
	public static void setCachingState(boolean value)
	{
		cachingEnabled=value;
	}
	public static boolean cachingEnabled()
	{
		return cachingEnabled;
	}
    public static void resetCache()
    {
        if(instance != null)
            instance.clear();
    }
}
