/*
 * Created on 31.03.2003
 *
 * To change this generated comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.n52.wmsclientcore;


import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;

import org.apache.log4j.Logger;

/**
 * @author <a href="mailto:senkler@ifgi.uni-muenster.de">Kristian Senkler</a>
 *
 * A WmsCollection organizes all published WebMapServices. A wmsID is the URL
 * specifying the online location of the wms.
 */
public class WmsCollection extends HashMap implements Serializable {

    private static Logger logger = Logger.getLogger(WmsCollection.class.getName());
   
/*
 * this map holds for each WMS an layerMap
 */




    // parameters for map request
//    private String width;
//    private String height;
//    private String format;

    /**
     * Creates a new instance
     */
/*    public WmsCollection(String width, String height, String format) {

        // init members
        this.width = width;
        this.height = height;
        this.format = format;

        this.setHeight(height);
        this.setWidth(width);
        this.setFormat(format);

        this.imageOverlay = new ImageOverlay();
        this.requestMap = Collections.synchronizedMap(new HashMap());
        this.layerList = new ArrayList();

        logger.info("WMSCollection initalized with following global parameters:");
        logger.info("width: " + this.width);
        logger.info("heigth: " + this.height);
        logger.info("format: " + this.format);

    }*/
		public WmsCollection()
		{
			
		}
		
    /**
     * Adds a new WebMapService
     * @param url
     */
    public void addWebMapService(String url) throws WmsException {
        WebMapService wms = new WebMapService(url);
        put(url, wms);


    }
		public void addWebMapService(String url, String version) throws WmsException
		{
			WebMapService wms = new WebMapService(url, version);
			put(url, wms);
		}

    /**
     * returns a WebMapService identified by id which is the
     * url of the WMS.
     * @param id
     * @return WebMapService
     */
    public WebMapService getWebMapService(String id) {
        if (containsKey(id))
            return (WebMapService) get(id);
        else
            return null;
    }

    /**
     * returns a WebMapService identified by id which is the
     * url of the WMS. If the current id does not exist within
     * the collection, the WMS is added and a new WebMapService
     * instance is returned.
     * @param id
     * @return WebMapService
     */
//    public WebMapService getAndAddWebMapService(String id) {
//        WebMapService wms = null;
//        if (containsKey(id)) {
//            wms = (WebMapService) get(id);
//        } else {
//            try {
//                wms = new WebMapService(id);
//                put(id, wms);
//            }} 
//            //catch (WmsException mE) {
//              //  logger.error(mE);
//            
//        }
//        return wms;
//    }

    /**
     * Returns a list with all published WMS.
     * @return Collection
     */
    public Collection getPublishedWMS() {
        return this.values();
    }

    /**
     * Deletes WMS by ID.
     * @param wmsID
     */
    public void deleteWMSByID(String wmsID) {
        // remove from WmsCollection
        if (this.containsKey(wmsID)) {
            this.remove(wmsID);
        }
        // remove from requestMap
//        if (requestMap.containsKey(wmsID)) {
//            requestMap.remove(wmsID);
//        }
//        Iterator iter = layerList.iterator();
//        while (iter.hasNext()) {
//            NameValuePair nvp = (NameValuePair) iter.next();
//            if (wmsID.equals((String) nvp.getName())) {
//                layerList.remove(nvp);
//                iter = layerList.iterator();
//            }
//        }
    }

    /**
     * Sets the current WmcBoundingBox for each WMSRequest
     * @param bbox
     */
//    public void setBoundingBox(WmcBoundingBox bbox) {
//        for (Iterator i = keySet().iterator(); i.hasNext();) {
//            String wmskey = (String) i.next();
//            HashMap layerMap = (HashMap) requestMap.get(wmskey);
//            for (Iterator ii = layerMap.entrySet().iterator(); ii.hasNext();) {
//                Map.Entry e = (Map.Entry) ii.next();
//                ((GetMapRequest) e.getValue()).setBbox(bbox);
//								((GetMapRequest) e.getValue()).setCrs(bbox.getSRS());
//            }
//        }
//        this.actualMapExtent = bbox;
//    }

    /**
     * Sets the current return format for each WMSRequest
     * @param format
     */
//    public void setFormat(String format) {
//        for (Iterator i = keySet().iterator(); i.hasNext();) {
//            String wmskey = (String) i.next();
//            HashMap layerMap = (HashMap) requestMap.get(wmskey);
//            for (Iterator ii = layerMap.entrySet().iterator(); ii.hasNext();) {
//                Map.Entry e = (Map.Entry) ii.next();
//                ((GetMapRequest) e.getValue()).setFormat(format);
//            }
//        }
//    }

    /**
     * Sets the current width for the result image for each WMSRequest
     * @param width
     */
//    public void setWidth(String width) {
//        for (Iterator i = keySet().iterator(); i.hasNext();) {
//            String wmskey = (String) i.next();
//            HashMap layerMap = (HashMap) requestMap.get(wmskey);
//            for (Iterator ii = layerMap.entrySet().iterator(); ii.hasNext();) {
//                Map.Entry e = (Map.Entry) ii.next();
//                ((GetMapRequest) e.getValue()).setWidth(width);
//            }
//        }
//    }

    /**
     * Sets the current height for the result image for each WMSRequest
     * @param height
     */
//    public void setHeight(String height) {
//        for (Iterator i = keySet().iterator(); i.hasNext();) {
//            String wmskey = (String) i.next();
//            HashMap layerMap = (HashMap) requestMap.get(wmskey);
//            for (Iterator ii = layerMap.entrySet().iterator(); ii.hasNext();) {
//                Map.Entry e = (Map.Entry) ii.next();
//                ((GetMapRequest) e.getValue()).setHeight(height);
//            }
//        }
//    }

    /**
     * Set layer and corresponding style for a specific WMS identified by
     * WMSID that is the WMS' URL
     * @param WMSID
     * @param layerName
     * @param styleName
     */
//    public void setLayerAndStyle(String WMSID, String layerName, String styleName) {
//        if (requestMap.containsKey(WMSID)) {
//            Map layerMap = (Map) requestMap.get(WMSID);
//            ((GetMapRequest) layerMap.get(layerName)).setLayers(layerName);
//					((GetMapRequest) layerMap.get(layerName)).setStyles(styleName);
//        }
//        // set order of layers
//        //checks if layerName and WMSID still exists in layerList (Theo)
//        boolean layerExists = false;
//        Iterator iter = layerList.iterator();
//        while (iter.hasNext()) {
//            NameValuePair nvp = (NameValuePair) iter.next();
//            if (nvp.getName().equals((String) WMSID) && nvp.getValue().equals((String) layerName))
//                layerExists = true;
//        }
//        if (!layerExists)
//            layerList.add(new NameValuePair(WMSID, layerName));
//    }

    /**
     * Removes a layer from the request map.
     * @param WMSID
     * @param layerName
     */
//    public void removeLayerFromRequest(String WMSID, String layerName) {
//        if (requestMap.containsKey(WMSID)) {
//            Map layerMap = (Map) requestMap.get(WMSID);
//             
//        }
//        // update Layer Order
//        int counter = 0;
//        int hit = -1;
//        for (Iterator ii = layerList.iterator(); ii.hasNext();) {
//            NameValuePair nvp = (NameValuePair) ii.next();
//            if (nvp.getValue().equals(layerName))
//                hit = counter;
//            counter++;
//        }
//        if (hit != -1)
//            layerList.remove(hit);
//    }

//		public String[] getCommonCrs()
//		{
//			Iterator iter = this.getPublishedWMS().iterator();
//			String[] returnArray = ((WebMapService)iter.next()).getCapabilities().getRootLayer().getCRS();
//			while(iter.hasNext())
//			{
//				String[] secondArray =((WebMapService)iter.next()).getCapabilities().getRootLayer().getCRS();
//				returnArray = this.blend(returnArray, secondArray);	
//			}
//			return returnArray;
//		}
		private String[] blend(String[] a, String[] b)
		{
			ArrayList returnList = new ArrayList();
			for(int i = 0; i < a .length; i++)
			{
				for(int j = 0; j<b.length;j++)
				{
					if(a[i].equals(b[j]))
						returnList.add(a[i]);
				}
			}
			String[] returnArray = new String[returnList.size()];
			Iterator iter = returnList.iterator();
			int counter = 0;
			while(iter.hasNext())
			{
				returnArray[counter]=(String)iter.next();
				counter ++;
			}
			return returnArray;
		}
    /**
     * Return a list that contains current layer names in the chosen order.
     * @return ArrayList
     */
    // TODO Ueberpruefen, ob diese Methode noetig ist.
//    public ArrayList getSelectedLayerNames() {
//        return this.layerList;
//    }

    /**
     * Returns the full extend of all WebMapServices stored in the collection.
     * A target SRS must be passed to this method.
     * @param inSRS
     * @return WmcBoundingBox
     */
    public WmcBoundingBox getFullExtend(String inSRS) {

        WmcBoundingBox resultBox = null;
//        resultBox.setSRS(inSRS);

//        Point2D ll = null;
//        Point2D ur = null;







        for (Iterator i = getPublishedWMS().iterator(); i.hasNext();) {
            WebMapService wms = (WebMapService) i.next();
            WmcBoundingBox bbox = wms.getFullExtend(inSRS);

				if (bbox != null) {
					if (resultBox == null) resultBox = bbox;
					else resultBox.union(bbox);
				} 

/*
            if (ll == null && ur == null) {
                ll = bbox.getLowerLeftAsDoublePoint();
                ur = bbox.getUpperRightAsDoublePoint();
            } else {
                if (bbox.getLowerLeftAsDoublePoint().getX() < ll.getX()) {
                    ll.setLocation(bbox.getLowerLeftAsDoublePoint().getX(), ll.getY());
                }
                if (bbox.getLowerLeftAsDoublePoint().getY() < ll.getY()) {
                    ll.setLocation(ll.getX(), bbox.getLowerLeftAsDoublePoint().getY());
                }
                if (bbox.getUpperRightAsDoublePoint().getX() > ur.getX()) {
                    ur.setLocation(bbox.getUpperRightAsDoublePoint().getX(), ur.getY());
                }
                if (bbox.getUpperRightAsDoublePoint().getY() > ur.getY()) {
                    ur.setLocation(ur.getX(), bbox.getUpperRightAsDoublePoint().getY());
                }
            }
        }
        resultBox.setBBox(ll, ur);
  */
    }
		return resultBox;
    }

    /**
     * Returns the current map extend
     * @return WmcBoundingBox - actual map extent
     */
//    public WmcBoundingBox getActualMapExtent() {
//        return this.actualMapExtent;
//    }

    /**
     * Returns the current map extend
     */
//    public void setActualMapExtent(WmcBoundingBox extent) {
//        this.actualMapExtent = extent;
//
//        // update wms
//        this.setBoundingBox(extent);
//    }

    /**
     *
     * @param bbox
     */
//    public void setHomeMapExtent(WmcBoundingBox bbox) {
//        this.homeMapExtent = bbox;
//    }

    /**
     *
     * @return Home map extent
     */
//    public WmcBoundingBox getHomeMapExtent() {
//        return homeMapExtent;
//    }

    //=======================================
    // WMS Operations
    //=======================================

    /**
     * GetMap will be called for each WMS stored by the collection.
     *
     * @return PlanarImage
     */
//    public PlanarImage getMap() {
//
//        // clear image list
//        imageOverlay.clearImageList();
//
//        // iterate through wms
//        for (ListIterator itr = layerList.listIterator(); itr.hasNext();) {
//            NameValuePair nvp = (NameValuePair) itr.next();
//					GetMapRequest obj = ((GetMapRequest) ((Map) requestMap.get(nvp.getName())).get(nvp.getValue()));
//            obj.setFormat(format);
//            obj.setHeight(height);
//            obj.setWidth(width);
//            //to set up the BBox for each MapRequest.
//            obj.setBbox(this.getActualMapExtent());
//            obj.setCrs(this.getActualMapExtent().getSRS());
//            WebMapService wms = this.getWebMapService(nvp.getName());
//            imageOverlay.addImage(wms.getMap(obj));
//        }
//
//        return imageOverlay.doOverlay();
//    }

    /**
     * Return a GetFeatureInfo based on given x,y
     * @param x
     * @param y
     * @return String[]
     */
//    public String[] getFeatureInfo(int x, int y, String info_format) {
//        WebMapService wms = null;
//        String[] resultList = new String[layerList.size()];
//        int counter = 0;
//        FeatureInfoRequest info = new FeatureInfoRequest();
//        info.setInfoFormat(info_format);
//        info.setX(String.valueOf(x));
//        info.setY(String.valueOf(y));
//
//        for (ListIterator itr = layerList.listIterator(); itr.hasNext();) {
//            NameValuePair nvp = (NameValuePair) itr.next();
//            GetMapRequest obj = (GetMapRequest) ((Map) requestMap.get(nvp.getName())).get(nvp.getValue());
//            wms = this.getWebMapService(nvp.getName());
//            //info.setPartialMapRequest(obj);
//            resultList[counter] = wms.getFeatureInfo(info);
//            counter++;
//        }
//        return resultList;
//    }
//	public void putLayerOnTop(String WMSID, String layerName)
//	{
//		//layerList.
//		Iterator iter = layerList.iterator();
//		int layerListpos = 0;
//		while(iter.hasNext())
//		{
//			
//			NameValuePair nvp = (NameValuePair)iter.next();
//			if (nvp.getName().equals((String) WMSID) && nvp.getValue().equals((String) layerName))
//			{
//				break; 
//			}
//			layerListpos++;
//		}
//		ArrayList newSortedList = new ArrayList();
//		newSortedList.add(layerList.get(layerListpos));
//		layerList.remove(layerListpos);
//		iter = layerList.iterator();
//		while(iter.hasNext())
//		{
//			newSortedList.add(iter.next());
//		}
//		layerList = newSortedList;
//	}


    /**
     * Returns the requestMap.
     * @return Map
     */
    // TODO : was macht diese Methode????
//    public Map getRequestMap() {
//        return requestMap;
//    }

}
