package org.n52.wmsclientcore.capabilities.model;

import org.n52.wmsclientcore.capabilities.util.CapabilitiesElement;
import org.w3c.dom.Element;


/*
 * This class was automatically generated with 
 * <a href="http://www.castor.org">Castor 0.9.5.2</a>, using an XML
 * Schema.
 * $Id: Capability.java,v 1.1 2007/01/11 09:55:10 arne_broering Exp $
 */

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/


/**
 * A Capability lists available request types, how exceptions may
 * be
 *  reported, and whether any vendor-specific capabilities are
 * defined.
 *  It also includes an optional list of map layers available from
 * this
 *  server.
 *  
 * 
 * @version $Revision: 1.1 $ $Date: 2007/01/11 09:55:10 $
 */
public abstract class Capability extends CapabilitiesElement implements java.io.Serializable {
	
	public Capability(Element elem)
	{
		super(elem);
		this.getLayer().checkForInheritedAttributesInLayerList();
	}
	/*
	 * This method is needed to inherit LayerAttributes like dimension.
	 */

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Available WMS Operations are listed in a Request element.
     *  
     */
    private Request _request;

    /**
     * An Exception element indicates which error-reporting formats
     * are
     *  supported.
     *  
     */
    private Exception _exception;

    /**
     * Individual vendors may use this element to report
     * vendor-specific
     *  capabilities.
     *  
     */
    private java.lang.Object _vendorSpecificCapabilities;

    /**
     * Nested list of zero or more map Layers offered by this
     * server.
     *  
     */
    private Layer _layer;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Returns the value of field 'exception'. The field
     * 'exception' has the following description: An Exception
     * element indicates which error-reporting formats are
     *  supported.
     *  
     * 
     * @return the value of field 'exception'.
     */
    public Exception getException()
    {
        return this._exception;
    } //-- Exception getException() 

    /**
     * Returns the value of field 'layer'. The field 'layer' has
     * the following description: Nested list of zero or more map
     * Layers offered by this server.
     *  
     * 
     * @return the value of field 'layer'.
     */
    public Layer getLayer()
    {
        return this._layer;
    } //-- Layer getLayer() 

    /**
     * Returns the value of field 'request'. The field 'request'
     * has the following description: Available WMS Operations are
     * listed in a Request element.
     *  
     * 
     * @return the value of field 'request'.
     */
    public Request getRequest()
    {
        return this._request;
    } //-- Request getRequest() 

    /**
     * Returns the value of field 'vendorSpecificCapabilities'. The
     * field 'vendorSpecificCapabilities' has the following
     * description: Individual vendors may use this element to
     * report vendor-specific
     *  capabilities.
     *  
     * 
     * @return the value of field 'vendorSpecificCapabilities'.
     */
    public java.lang.Object getVendorSpecificCapabilities()
    {
        return this._vendorSpecificCapabilities;
    } //-- java.lang.Object getVendorSpecificCapabilities() 

    /**
     * Sets the value of field 'exception'. The field 'exception'
     * has the following description: An Exception element
     * indicates which error-reporting formats are
     *  supported.
     *  
     * 
     * @param exception the value of field 'exception'.
     */
    public void setException(Exception exception)
    {
        this._exception = exception;
    } //-- void setException(Exception) 

    /**
     * Sets the value of field 'layer'. The field 'layer' has the
     * following description: Nested list of zero or more map
     * Layers offered by this server.
     *  
     * 
     * @param layer the value of field 'layer'.
     */
    public void setLayer(Layer layer)
    {
        this._layer = layer;
    } //-- void setLayer(Layer) 

    /**
     * Sets the value of field 'request'. The field 'request' has
     * the following description: Available WMS Operations are
     * listed in a Request element.
     *  
     * 
     * @param request the value of field 'request'.
     */
    public void setRequest(Request request)
    {
        this._request = request;
    } //-- void setRequest(Request) 

    /**
     * Sets the value of field 'vendorSpecificCapabilities'. The
     * field 'vendorSpecificCapabilities' has the following
     * description: Individual vendors may use this element to
     * report vendor-specific
     *  capabilities.
     *  
     * 
     * @param vendorSpecificCapabilities the value of field
     * 'vendorSpecificCapabilities'.
     */
    public void setVendorSpecificCapabilities(java.lang.Object vendorSpecificCapabilities)
    {
        this._vendorSpecificCapabilities = vendorSpecificCapabilities;
    } //-- void setVendorSpecificCapabilities(java.lang.Object) 

}
