/*
 * This class was automatically generated with 
 * <a href="http://www.castor.org">Castor 0.9.5.2</a>, using an XML
 * Schema.
 * $Id: Layer.java,v 1.1 2007/01/11 09:55:10 arne_broering Exp $
 */

//---------------------------------/
//- Imported classes and packages -/
//---------------------------------/
package org.n52.wmsclientcore.capabilities.model;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Vector;

import org.n52.wmsclientcore.capabilities.util.CapabilitiesElement;
import org.w3c.dom.Element;


/**
 * Nested list of zero or more map Layers offered by this server.
 * 
 * 
 * @version $Revision: 1.1 $ $Date: 2007/01/11 09:55:10 $
 */
public abstract class Layer extends CapabilitiesElement implements
		java.io.Serializable {

	//--------------------------/
	//- Class/Member Variables -/
	//--------------------------/

	/**
	 * Field _queryable
	 */
	private boolean _queryable = false;

	/**
	 * keeps track of state for field: _queryable
	 */
	private boolean _has_queryable;

	/**
	 * Field _cascaded
	 */
	private int _cascaded;

	/**
	 * keeps track of state for field: _cascaded
	 */
	private boolean _has_cascaded;

	/**
	 * Field _opaque
	 */
	private boolean _opaque = false;

	/**
	 * keeps track of state for field: _opaque
	 */
	private boolean _has_opaque;

	/**
	 * Field _noSubsets
	 */
	private boolean _noSubsets = false;

	/**
	 * keeps track of state for field: _noSubsets
	 */
	private boolean _has_noSubsets;

	/**
	 * Field _fixedWidth
	 */
	private int _fixedWidth;

	/**
	 * keeps track of state for field: _fixedWidth
	 */
	private boolean _has_fixedWidth;

	/**
	 * Field _fixedHeight
	 */
	private int _fixedHeight;

	/**
	 * keeps track of state for field: _fixedHeight
	 */
	private boolean _has_fixedHeight;

	/**
	 * The Name is typically for machine-to-machine communication.
	 *  
	 */
	private java.lang.String _name;

	/**
	 * The Title is for informative display to a human.
	 *  
	 */
	private java.lang.String _title;

	/**
	 * The abstract is a longer narrative description of an object.
	 *  
	 */
	private java.lang.String _abstract;

	/**
	 * List of keywords or keyword phrases to help catalog searching.
	 *  
	 */
	private KeywordList _keywordList;

	/**
	 * Identifier for a single Coordinate Reference System (CRS).
	 *  
	 */
	private java.util.Vector _CRSList;

	/**
	 * The EX_GeographicBoundingBox attributes indicate the edges of the
	 * enclosing rectangle in longitude and latitude decimal degrees.
	 *  
	 */
	private EX_GeographicBoundingBox _EX_GeographicBoundingBox;

	/**
	 * The BoundingBox attributes indicate the edges of the bounding box in
	 * units of the specified coordinate reference system.
	 *  
	 */
	private java.util.Map _boundingBoxList;

	/**
	 * The Dimension element declares the existence of a dimension and indicates
	 * what values along a dimension are valid.
	 *  
	 */
	private java.util.Map _dimensionList;

	/**
	 * Attribution indicates the provider of a Layer or collection of Layers.
	 * The provider's URL, descriptive title string, and/or logo image URL may
	 * be supplied. Client applications may choose to display one or more of
	 * these items. A format element indicates the MIME type of the logo image
	 * located at LogoURL. The logo image's width and height assist client
	 * applications in laying out space to display the logo.
	 *  
	 */
	private Attribution _attribution;

	/**
	 * A Map Server may use zero or more Identifier elements to list ID numbers
	 * or labels defined by a particular Authority. For example, the Global
	 * Change Master Directory (gcmd.gsfc.nasa.gov) defines a DIF_ID label for
	 * every dataset. The authority name and explanatory URL are defined in a
	 * separate AuthorityURL element, which may be defined once and inherited by
	 * subsidiary layers. Identifiers themselves are not inherited.
	 *  
	 */
	private java.util.Vector _authorityURLList;

	/**
	 * Field _identifierList
	 */
	private java.util.Vector _identifierList;

	/**
	 * A Map Server may use zero or more MetadataURL elements to offer detailed,
	 * standardized metadata about the data underneath a particular layer. The
	 * type attribute indicates the standard to which the metadata complies. The
	 * format element indicates how the metadata is structured.
	 *  
	 */
	private java.util.Vector _metadataURLList;

	/**
	 * A Map Server may use DataURL to offer more information about the data
	 * underneath a particular layer. While the semantics are not well-defined,
	 * as long as the results of an HTTP GET request against the DataURL are
	 * properly MIME-typed, Viewer Clients and Cascading Map Servers can make
	 * use of this.
	 *  
	 */
	private java.util.Vector _dataURLList;

	/**
	 * A Map Server may use FeatureListURL to point to a list of the features
	 * represented in a Layer.
	 *  
	 */
	private java.util.Vector _featureListURLList;

	/**
	 * A Style element lists the name by which a style is requested and a
	 * human-readable title for pick lists, optionally (and ideally) provides a
	 * human-readable description, and optionally gives a style URL.
	 *  
	 */
	private java.util.Vector _styleList;

	/**
	 * Minimum scale denominator for which it is appropriate to display this
	 * layer.
	 *  
	 */
	private double _minScaleDenominator;

	/**
	 * keeps track of state for field: _minScaleDenominator
	 */
	private boolean _has_minScaleDenominator;

	/**
	 * Maximum scale denominator for which it is appropriate to display this
	 * layer.
	 *  
	 */
	private double _maxScaleDenominator;

	/**
	 * keeps track of state for field: _maxScaleDenominator
	 */
	private boolean _has_maxScaleDenominator;

	/**
	 * Nested list of zero or more map Layers offered by this server.
	 *  
	 */
	private java.util.Vector _layerList;

	protected Layer parent;

	//----------------/
	//- Constructors -/
	//----------------/
	public Layer(Element elem) {
		this(elem, null);

		//this(elem, null);
	}

	public Layer(Element elem, Layer parent) {
		super(elem);
		this.parent = parent;

	} //-- Layer()

	public void checkForInheritedAttributesInLayerList() {
		if (this.getLayer() != null) {
			for (int i = 0; i < this.getLayerCount(); i++) {
				if (!this.getLayer(i).isRoot())
					this.getLayer(i).initInheritedAttributeValues();
				this.getLayer(i).checkForInheritedAttributesInLayerList();
			}
		}
	}

	public void init() {
		_CRSList = new Vector();
		_boundingBoxList = new HashMap();
		_dimensionList = new HashMap();
		_authorityURLList = new Vector();
		_identifierList = new Vector();
		_metadataURLList = new Vector();
		_dataURLList = new Vector();
		_featureListURLList = new Vector();
		_styleList = new Vector();
		_layerList = new Vector();

	}

	/*
	 * initializing the inherited Values. This has to be done, to have a good
	 * add Method
	 */
	public Style getStyleByName(String name) {
		for (int i = 0; i < _styleList.size(); i++) {
			if (((Style) _styleList.get(i)).getName().equals(name))
				return (Style) _styleList.get(i);
		}
		return null;
	}

	private void initInheritedAttributeValues() {
		Iterator itr = parent.getBoundingBoxIterator();
		while (itr.hasNext()) {
			BoundingBox tempBox = (BoundingBox) ((Map.Entry) itr.next())
					.getValue();
			this.addBoundingBox(tempBox);
		}
		itr = parent.getDimensionIterator();
		//Attention not spec conformant, but nessecary to not override content!
		while (itr.hasNext()) {
			Dimension tempDim = (Dimension) ((Map.Entry) itr.next()).getValue();
			if(!this.dimensionExists(tempDim.getName()))
				this.addDimension((Dimension)tempDim.clone());
		}
		this.initExtent();
		if (!this.getEX_GeographicBoundingBox().isMeaningful())
			this.setEX_GeographicBoundingBox(parent
					.getEX_GeographicBoundingBox());
	}

	/*
	 * indicates if layer is a rootLayer
	 */
	public boolean isRoot() {
		return this.parent == null;
	}
	/**
	 * This is only for temporary use.
	 * Inits the Extent Element of 1.1.1 & 1.1.0. and puts it in the dimensionElement, which is inherited.
	 *
	 */
	protected abstract void initExtent();
	/*
	 * indicates if the layer is a named one
	 */
	public boolean isNamed() {
		return (this._name != null);
	}

	public void fillLayerList(ArrayList list) {
		list.add(this);
		if (_layerList != null) {
			Iterator itr = this._layerList.iterator();
			while (itr.hasNext())
				((Layer) itr.next()).fillLayerList(list);
		}

	}

	/*
	 * To retrieve a dimension by name
	 */
	public Dimension getDimensionByName(String name) {
		return (Dimension) _dimensionList.get(name);
	}

	/*
	 * To check if a specific dimension exists
	 */
	public boolean dimensionExists(String name) {
		return _dimensionList.containsKey(name);
	}
	public boolean dimensionHasContents(String name)
	{
		if (_dimensionList.containsKey(name))
			{if(!(((Dimension)_dimensionList.get(name)).getContent()).equals(""))
				return true;
			}
		return false;
			
	}

	//-----------/
	//- Methods -/
	//-----------/

	/**
	 * Method addAuthorityURL
	 * 
	 * @param vAuthorityURL
	 */
	protected Layer getParentLayer() {
		return parent;
	}

	public void addAuthorityURL(AuthorityURL vAuthorityURL)
			throws java.lang.IndexOutOfBoundsException {
		_authorityURLList.addElement(vAuthorityURL);
	} //-- void addAuthorityURL(AuthorityURL)

	/**
	 * Method addAuthorityURL
	 * 
	 * @param index
	 * @param vAuthorityURL
	 */
	public void addAuthorityURL(int index, AuthorityURL vAuthorityURL)
			throws java.lang.IndexOutOfBoundsException {
		_authorityURLList.insertElementAt(vAuthorityURL, index);
	} //-- void addAuthorityURL(int, AuthorityURL)

	/**
	 * Method addBoundingBox The Method is changed a little bit, cause the
	 * BoundingBoxes are unique by the CRS This CRS is used as the key for the
	 * HashMap entry
	 * 
	 * @param vBoundingBox
	 */
	public void addBoundingBox(BoundingBox vBoundingBox)
			throws java.lang.IndexOutOfBoundsException {

		_boundingBoxList.put(vBoundingBox.getCRS(), vBoundingBox);
	} //-- void addBoundingBox(BoundingBox)

	/**
	 * Method addCRS
	 * 
	 * @param vCRS
	 */
	public void addCRS(java.lang.String vCRS)
			throws java.lang.IndexOutOfBoundsException {
		_CRSList.addElement(vCRS);
	} //-- void addCRS(java.lang.String)

	/**
	 * Method addCRS
	 * 
	 * @param index
	 * @param vCRS
	 */
	public void addCRS(int index, java.lang.String vCRS)
			throws java.lang.IndexOutOfBoundsException {
		_CRSList.insertElementAt(vCRS, index);
	} //-- void addCRS(int, java.lang.String)

	/**
	 * Method addDataURL
	 * 
	 * @param vDataURL
	 */
	public void addDataURL(DataURL vDataURL)
			throws java.lang.IndexOutOfBoundsException {
		_dataURLList.addElement(vDataURL);
	} //-- void addDataURL(DataURL)

	/**
	 * Method addDataURL
	 * 
	 * @param index
	 * @param vDataURL
	 */
	public void addDataURL(int index, DataURL vDataURL)
			throws java.lang.IndexOutOfBoundsException {
		_dataURLList.insertElementAt(vDataURL, index);
	} //-- void addDataURL(int, DataURL)

	/**
	 * Method addDimension
	 * 
	 * @param vDimension
	 */
	public void addDimension(Dimension vDimension)
			throws java.lang.IndexOutOfBoundsException {
		_dimensionList.put(vDimension.getName(), vDimension);
	} //-- void addDimension(Dimension)

	/**
	 * Method addDimension
	 * 
	 * @param index
	 * @param vDimension
	 */
	/*
	 * public void addDimension(int index, Dimension vDimension) throws
	 * java.lang.IndexOutOfBoundsException {
	 * _dimensionList.insertElementAt(vDimension, index); }
	 *///-- void addDimension(int, Dimension)
	/**
	 * Method addFeatureListURL
	 * 
	 * @param vFeatureListURL
	 */
	public void addFeatureListURL(FeatureListURL vFeatureListURL)
			throws java.lang.IndexOutOfBoundsException {
		_featureListURLList.addElement(vFeatureListURL);
	} //-- void addFeatureListURL(FeatureListURL)

	/**
	 * Method addFeatureListURL
	 * 
	 * @param index
	 * @param vFeatureListURL
	 */
	public void addFeatureListURL(int index, FeatureListURL vFeatureListURL)
			throws java.lang.IndexOutOfBoundsException {
		_featureListURLList.insertElementAt(vFeatureListURL, index);
	} //-- void addFeatureListURL(int, FeatureListURL)

	/**
	 * Method addIdentifier
	 * 
	 * @param vIdentifier
	 */
	public void addIdentifier(Identifier vIdentifier)
			throws java.lang.IndexOutOfBoundsException {
		_identifierList.addElement(vIdentifier);
	} //-- void addIdentifier(Identifier)

	/**
	 * Method addIdentifier
	 * 
	 * @param index
	 * @param vIdentifier
	 */
	public void addIdentifier(int index, Identifier vIdentifier)
			throws java.lang.IndexOutOfBoundsException {
		_identifierList.insertElementAt(vIdentifier, index);
	} //-- void addIdentifier(int, Identifier)

	/**
	 * Method addLayer
	 * 
	 * @param vLayer
	 */
	public void addLayer(Layer vLayer)
			throws java.lang.IndexOutOfBoundsException {
		_layerList.addElement(vLayer);
	} //-- void addLayer(Layer)

	/**
	 * Method addLayer
	 * 
	 * @param index
	 * @param vLayer
	 */
	public void addLayer(int index, Layer vLayer)
			throws java.lang.IndexOutOfBoundsException {
		_layerList.insertElementAt(vLayer, index);
	} //-- void addLayer(int, Layer)

	/**
	 * Method addMetadataURL
	 * 
	 * @param vMetadataURL
	 */
	public void addMetadataURL(MetadataURL vMetadataURL)
			throws java.lang.IndexOutOfBoundsException {
		_metadataURLList.addElement(vMetadataURL);
	} //-- void addMetadataURL(MetadataURL)

	/**
	 * Method addMetadataURL
	 * 
	 * @param index
	 * @param vMetadataURL
	 */
	public void addMetadataURL(int index, MetadataURL vMetadataURL)
			throws java.lang.IndexOutOfBoundsException {
		_metadataURLList.insertElementAt(vMetadataURL, index);
	} //-- void addMetadataURL(int, MetadataURL)

	/**
	 * Method addStyle
	 * 
	 * @param vStyle
	 */
	public void addStyle(Style vStyle)
			throws java.lang.IndexOutOfBoundsException {
		_styleList.addElement(vStyle);
	} //-- void addStyle(Style)

	/**
	 * Method addStyle
	 * 
	 * @param index
	 * @param vStyle
	 */
	public void addStyle(int index, Style vStyle)
			throws java.lang.IndexOutOfBoundsException {
		_styleList.insertElementAt(vStyle, index);
	} //-- void addStyle(int, Style)

	/**
	 * Method deleteCascaded
	 */
	public void deleteCascaded() {
		this._has_cascaded = false;
	} //-- void deleteCascaded()

	/**
	 * Method deleteFixedHeight
	 */
	public void deleteFixedHeight() {
		this._has_fixedHeight = false;
	} //-- void deleteFixedHeight()

	/**
	 * Method deleteFixedWidth
	 */
	public void deleteFixedWidth() {
		this._has_fixedWidth = false;
	} //-- void deleteFixedWidth()

	/**
	 * Method deleteMaxScaleDenominator
	 */
	public void deleteMaxScaleDenominator() {
		this._has_maxScaleDenominator = false;
	} //-- void deleteMaxScaleDenominator()

	/**
	 * Method deleteMinScaleDenominator
	 */
	public void deleteMinScaleDenominator() {
		this._has_minScaleDenominator = false;
	} //-- void deleteMinScaleDenominator()

	/**
	 * Method deleteNoSubsets
	 */
	public void deleteNoSubsets() {
		this._has_noSubsets = false;
	} //-- void deleteNoSubsets()

	/**
	 * Method deleteOpaque
	 */
	public void deleteOpaque() {
		this._has_opaque = false;
	} //-- void deleteOpaque()

	/**
	 * Method deleteQueryable
	 */
	public void deleteQueryable() {
		this._has_queryable = false;
	} //-- void deleteQueryable()

	/**
	 * Method enumerateAuthorityURL
	 */
	public java.util.Enumeration enumerateAuthorityURL() {
		return _authorityURLList.elements();
	} //-- java.util.Enumeration enumerateAuthorityURL()

	/**
	 * Method enumerateBoundingBox
	 */
	/*
	 * public java.util.Enumeration enumerateBoundingBox() { return
	 * _boundingBoxList.entrySet().; }
	 *///-- java.util.Enumeration enumerateBoundingBox()
	/**
	 * Method enumerateCRS
	 */
	public java.util.Enumeration enumerateCRS() {
		return _CRSList.elements();
	} //-- java.util.Enumeration enumerateCRS()

	/**
	 * Method enumerateDataURL
	 */
	public java.util.Enumeration enumerateDataURL() {
		return _dataURLList.elements();
	} //-- java.util.Enumeration enumerateDataURL()

	/**
	 * Method enumerateDimension
	 */
	/*
	 * public java.util.Enumeration enumerateDimension() { return
	 * _dimensionList.elements(); }
	 *///-- java.util.Enumeration enumerateDimension()
	/**
	 * Method enumerateFeatureListURL
	 */
	public java.util.Enumeration enumerateFeatureListURL() {
		return _featureListURLList.elements();
	} //-- java.util.Enumeration enumerateFeatureListURL()

	/**
	 * Method enumerateIdentifier
	 */
	public java.util.Enumeration enumerateIdentifier() {
		return _identifierList.elements();
	} //-- java.util.Enumeration enumerateIdentifier()

	/**
	 * Method enumerateLayer
	 */
	public java.util.Enumeration enumerateLayer() {
		return _layerList.elements();
	} //-- java.util.Enumeration enumerateLayer()

	/**
	 * Method enumerateMetadataURL
	 */
	public java.util.Enumeration enumerateMetadataURL() {
		return _metadataURLList.elements();
	} //-- java.util.Enumeration enumerateMetadataURL()

	/**
	 * Method enumerateStyle
	 */
	public java.util.Enumeration enumerateStyle() {
		return _styleList.elements();
	} //-- java.util.Enumeration enumerateStyle()

	/**
	 * Returns the value of field 'abstract'. The field 'abstract' has the
	 * following description: The abstract is a longer narrative description of
	 * an object.
	 * 
	 * 
	 * @return the value of field 'abstract'.
	 */
	public java.lang.String getAbstract() {
		return this._abstract;
	} //-- java.lang.String getAbstract()

	/**
	 * Returns the value of field 'attribution'. The field 'attribution' has the
	 * following description: Attribution indicates the provider of a Layer or
	 * collection of Layers. The provider's URL, descriptive title string,
	 * and/or logo image URL may be supplied. Client applications may choose to
	 * display one or more of these items. A format element indicates the MIME
	 * type of the logo image located at LogoURL. The logo image's width and
	 * height assist client applications in laying out space to display the
	 * logo.
	 * 
	 * 
	 * @return the value of field 'attribution'.
	 */
	public Attribution getAttribution() {
		return this._attribution;
	} //-- Attribution getAttribution()

	/**
	 * Method getAuthorityURL
	 * 
	 * @param index
	 */
	public AuthorityURL getAuthorityURL(int index)
			throws java.lang.IndexOutOfBoundsException {
		//-- check bounds for index
		if ((index < 0) || (index > _authorityURLList.size())) {
			throw new IndexOutOfBoundsException();
		}

		return (AuthorityURL) _authorityURLList.elementAt(index);
	} //-- AuthorityURL getAuthorityURL(int)

	/**
	 * Method getAuthorityURL
	 */
	public AuthorityURL[] getAuthorityURL() {
		int size = _authorityURLList.size();
		AuthorityURL[] mArray = new AuthorityURL[size];
		for (int index = 0; index < size; index++) {
			mArray[index] = (AuthorityURL) _authorityURLList.elementAt(index);
		}
		return mArray;
	} //-- AuthorityURL[] getAuthorityURL()

	/**
	 * Method getAuthorityURLCount
	 */
	public int getAuthorityURLCount() {
		return _authorityURLList.size();
	} //-- int getAuthorityURLCount()

	/**
	 * Method getBoundingBox
	 * 
	 * @param index
	 */
	public Iterator getBoundingBoxIterator() {
		//-- check bounds for index
		return _boundingBoxList.entrySet().iterator();
	} //-- BoundingBox getBoundingBox(int)

	/**
	 * Method getBoundingBox
	 */
	public BoundingBox[] getBoundingBox() {

		BoundingBox[] mArray = new BoundingBox[this._boundingBoxList.size()];
		Iterator itr = this._boundingBoxList.entrySet().iterator();
		int counter = 0;
		while (itr.hasNext()) {
			mArray[counter] = (BoundingBox) ((Map.Entry) itr.next()).getValue();
			counter++;
		}
		return mArray;
	} //-- BoundingBox[] getBoundingBox()

	/**
	 * Method getBoundingBoxCount
	 * 
	 * NOT APPLICABLE, ITERATOR IS ENOUGH
	 */
	/*
	 * public int getBoundingBoxCount() { return _boundingBoxList.size();
	 */
	//} //-- int getBoundingBoxCount()
	/**
	 * Method getCRS
	 * 
	 * @param index
	 */
	public java.lang.String getCRS(int index)
			throws java.lang.IndexOutOfBoundsException {
		//-- check bounds for index
		if ((index < 0) || (index > _CRSList.size())) {
			throw new IndexOutOfBoundsException();
		}

		return (String) _CRSList.elementAt(index);
	} //-- java.lang.String getCRS(int)

	/**
	 * Method getCRS
	 */
	public java.lang.String[] getCRS() {
		if (_CRSList == null)
			return new String[0];
		int size = _CRSList.size();
		java.lang.String[] mArray = new java.lang.String[size];
		for (int index = 0; index < size; index++) {
			mArray[index] = (String) _CRSList.elementAt(index);
		}
		return mArray;
	} //-- java.lang.String[] getCRS()

	public Vector getAllCRS() {
		return this.searchAllCRS(new Vector());
	}

	private Vector searchAllCRS(Vector vec) {
		if (!this.isRoot()) {
			vec.addAll(this.convert2Vector(this.getCRS()));
			parent.searchAllCRS(vec);
		}
		if (this.getCRS() != null)
			vec.addAll(convert2Vector(this.getCRS()));
		return vec;
	}

	/**
	 * Method getCRSCount
	 */
	public int getCRSCount() {
		return _CRSList.size();
	} //-- int getCRSCount()

	/**
	 * Returns the value of field 'cascaded'.
	 * 
	 * @return the value of field 'cascaded'.
	 */
	public int getCascaded() {
		return this._cascaded;
	} //-- int getCascaded()

	/**
	 * Method getDataURL
	 * 
	 * @param index
	 */
	public DataURL getDataURL(int index)
			throws java.lang.IndexOutOfBoundsException {
		//-- check bounds for index
		if ((index < 0) || (index > _dataURLList.size())) {
			throw new IndexOutOfBoundsException();
		}

		return (DataURL) _dataURLList.elementAt(index);
	} //-- DataURL getDataURL(int)

	/**
	 * Method getDataURL
	 */
	public DataURL[] getDataURL() {
		int size = _dataURLList.size();
		DataURL[] mArray = new DataURL[size];
		for (int index = 0; index < size; index++) {
			mArray[index] = (DataURL) _dataURLList.elementAt(index);
		}
		return mArray;
	} //-- DataURL[] getDataURL()

	/**
	 * Method getDataURLCount
	 */
	public int getDataURLCount() {
		return _dataURLList.size();
	} //-- int getDataURLCount()

	/**
	 * Method getDimension
	 * 
	 * @return an iterator with Map.Entry objects, which have to be casted
	 * @param index
	 */
	public Iterator getDimensionIterator()
			throws java.lang.IndexOutOfBoundsException {
		return this._dimensionList.entrySet().iterator();
	} //-- Dimension getDimension(int)

	/**
	 * Method getDimension
	 */
	public Dimension[] getDimension() {

		Dimension[] mArray = new Dimension[this._dimensionList.size()];
		Iterator itr = this._dimensionList.entrySet().iterator();
		int counter = 0;
		while (itr.hasNext()) {

			mArray[counter] = (Dimension) (Map.Entry) itr.next();
			counter++;
		}

		return mArray;
	} //-- Dimension[] getDimension()

	public Vector getAllDimension() {
		return this.searchAllDimension(new Vector());
	}

	/*
	 *  
	 */
	private Vector searchAllDimension(Vector vec) {
		if (!this.isRoot()) {
			vec.addAll(this.convert2Vector(this.getDimension()));
			parent.searchAllDimension(vec);
		}
		return vec;
	}

	/**
	 * Method getDimensionCount
	 */
	public int getDimensionCount() {
		return _dimensionList.size();
	} //-- int getDimensionCount()

	/**
	 * Returns the value of field 'EX_GeographicBoundingBox'. The field
	 * 'EX_GeographicBoundingBox' has the following description: The
	 * EX_GeographicBoundingBox attributes indicate the edges of the enclosing
	 * rectangle in longitude and latitude decimal degrees.
	 * 
	 * 
	 * @return the value of field 'EX_GeographicBoundingBox'.
	 */
	public EX_GeographicBoundingBox getEX_GeographicBoundingBox() {
		return this._EX_GeographicBoundingBox;
	} //-- EX_GeographicBoundingBox getEX_GeographicBoundingBox()

	/**
	 * Method getFeatureListURL
	 * 
	 * @param index
	 */
	public FeatureListURL getFeatureListURL(int index)
			throws java.lang.IndexOutOfBoundsException {
		//-- check bounds for index
		if ((index < 0) || (index > _featureListURLList.size())) {
			throw new IndexOutOfBoundsException();
		}

		return (FeatureListURL) _featureListURLList.elementAt(index);
	} //-- FeatureListURL getFeatureListURL(int)

	/**
	 * Method getFeatureListURL
	 */
	public FeatureListURL[] getFeatureListURL() {
		int size = _featureListURLList.size();
		FeatureListURL[] mArray = new FeatureListURL[size];
		for (int index = 0; index < size; index++) {
			mArray[index] = (FeatureListURL) _featureListURLList
					.elementAt(index);
		}
		return mArray;
	} //-- FeatureListURL[] getFeatureListURL()

	/**
	 * Method getFeatureListURLCount
	 */
	public int getFeatureListURLCount() {
		return _featureListURLList.size();
	} //-- int getFeatureListURLCount()

	/**
	 * Returns the value of field 'fixedHeight'.
	 * 
	 * @return the value of field 'fixedHeight'.
	 */
	public int getFixedHeight() {
		return this._fixedHeight;
	} //-- int getFixedHeight()

	/**
	 * Returns the value of field 'fixedWidth'.
	 * 
	 * @return the value of field 'fixedWidth'.
	 */
	public int getFixedWidth() {
		return this._fixedWidth;
	} //-- int getFixedWidth()

	/**
	 * Method getIdentifier
	 * 
	 * @param index
	 */
	public Identifier getIdentifier(int index)
			throws java.lang.IndexOutOfBoundsException {
		//-- check bounds for index
		if ((index < 0) || (index > _identifierList.size())) {
			throw new IndexOutOfBoundsException();
		}

		return (Identifier) _identifierList.elementAt(index);
	} //-- Identifier getIdentifier(int)

	/**
	 * Method getIdentifier
	 */
	public Identifier[] getIdentifier() {
		int size = _identifierList.size();
		Identifier[] mArray = new Identifier[size];
		for (int index = 0; index < size; index++) {
			mArray[index] = (Identifier) _identifierList.elementAt(index);
		}
		return mArray;
	} //-- Identifier[] getIdentifier()

	/**
	 * Method getIdentifierCount
	 */
	public int getIdentifierCount() {
		return _identifierList.size();
	} //-- int getIdentifierCount()

	/**
	 * Returns the value of field 'keywordList'. The field 'keywordList' has the
	 * following description: List of keywords or keyword phrases to help
	 * catalog searching.
	 * 
	 * 
	 * @return the value of field 'keywordList'.
	 */
	public KeywordList getKeywordList() {
		return this._keywordList;
	} //-- KeywordList getKeywordList()

	/**
	 * Method getLayer
	 * 
	 * @param index
	 */
	public Layer getLayer(int index) throws java.lang.IndexOutOfBoundsException {
		//-- check bounds for index
		if ((index < 0) || (index > _layerList.size())) {
			throw new IndexOutOfBoundsException();
		}

		return (Layer) _layerList.elementAt(index);
	} //-- Layer getLayer(int)

	/**
	 * Method getLayer
	 */
	public Layer[] getLayer() {
		if (_layerList == null)
			return null;
		int size = _layerList.size();
		Layer[] mArray = new Layer[size];
		for (int index = 0; index < size; index++) {
			mArray[index] = (Layer) _layerList.elementAt(index);
		}
		return mArray;
	} //-- Layer[] getLayer()

	/**
	 * Method getLayerCount
	 */
	public int getLayerCount() {
		return _layerList.size();
	} //-- int getLayerCount()

	/**
	 * Returns the value of field 'maxScaleDenominator'. The field
	 * 'maxScaleDenominator' has the following description: Maximum scale
	 * denominator for which it is appropriate to display this layer.
	 * 
	 * 
	 * @return the value of field 'maxScaleDenominator'.
	 */
	public double getMaxScaleDenominator() {
		return this._maxScaleDenominator;
	} //-- double getMaxScaleDenominator()

	/**
	 * Method getMetadataURL
	 * 
	 * @param index
	 */
	public MetadataURL getMetadataURL(int index)
			throws java.lang.IndexOutOfBoundsException {
		//-- check bounds for index
		if ((index < 0) || (index > _metadataURLList.size())) {
			throw new IndexOutOfBoundsException();
		}

		return (MetadataURL) _metadataURLList.elementAt(index);
	} //-- MetadataURL getMetadataURL(int)

	/**
	 * Method getMetadataURL
	 */
	public MetadataURL[] getMetadataURL() {
		int size = _metadataURLList.size();
		MetadataURL[] mArray = new MetadataURL[size];
		for (int index = 0; index < size; index++) {
			mArray[index] = (MetadataURL) _metadataURLList.elementAt(index);
		}
		return mArray;
	} //-- MetadataURL[] getMetadataURL()

	/**
	 * Method getMetadataURLCount
	 */
	public int getMetadataURLCount() {
		return _metadataURLList.size();
	} //-- int getMetadataURLCount()

	/**
	 * Returns the value of field 'minScaleDenominator'. The field
	 * 'minScaleDenominator' has the following description: Minimum scale
	 * denominator for which it is appropriate to display this layer.
	 * 
	 * 
	 * @return the value of field 'minScaleDenominator'.
	 */
	public double getMinScaleDenominator() {
		return this._minScaleDenominator;
	} //-- double getMinScaleDenominator()

	/**
	 * Returns the value of field 'name'. The field 'name' has the following
	 * description: The Name is typically for machine-to-machine communication.
	 * 
	 * 
	 * @return the value of field 'name'.
	 */
	public java.lang.String getName() {
		return this._name;
	} //-- java.lang.String getName()

	/**
	 * Returns the value of field 'noSubsets'.
	 * 
	 * @return the value of field 'noSubsets'.
	 */
	public boolean getNoSubsets() {
		return this._noSubsets;
	} //-- boolean getNoSubsets()

	/**
	 * Returns the value of field 'opaque'.
	 * 
	 * @return the value of field 'opaque'.
	 */
	public boolean getOpaque() {
		return this._opaque;
	} //-- boolean getOpaque()

	/**
	 * Returns the value of field 'queryable'.
	 * 
	 * @return the value of field 'queryable'.
	 */
	public boolean getQueryable() {
		return this._queryable;
	} //-- boolean getQueryable()

	/**
	 * Method getStyle
	 * 
	 * @param index
	 */
	public Style getStyle(int index) throws java.lang.IndexOutOfBoundsException {
		//-- check bounds for index
		if ((index < 0) || (index > _styleList.size())) {
			throw new IndexOutOfBoundsException();
		}

		return (Style) _styleList.elementAt(index);
	} //-- Style getStyle(int)

	/**
	 * Method getStyle
	 */
	public Style[] getStyle() {
		int size = _styleList.size();
		Style[] mArray = new Style[size];
		for (int index = 0; index < size; index++) {
			mArray[index] = (Style) _styleList.elementAt(index);
		}
		return mArray;
	} //-- Style[] getStyle()

	public Vector getAllStyles() {
		return searchAllStyles(new Vector());
	}

	/*
	 * recursive Method to harvest all styles in all parents.
	 */
	private Vector searchAllStyles(Vector vec) {
		if (!this.isRoot()) {
			vec.addAll(this.convert2Vector(this.getStyle()));
			parent.searchAllStyles(vec);
		}
		return vec;
	}

	/*
	 * some utility method to convert array2vector
	 */
	private Vector convert2Vector(Object[] array) {
		Vector ret = new Vector();
		for (int i = 0; i < array.length; i++) {
			ret.add(array[i]);
		}
		return ret;
	}

	/**
	 * Method getStyleCount
	 */
	public int getStyleCount() {
		return _styleList.size();
	} //-- int getStyleCount()

	/**
	 * Returns the value of field 'title'. The field 'title' has the following
	 * description: The Title is for informative display to a human.
	 * 
	 * 
	 * @return the value of field 'title'.
	 */
	public java.lang.String getTitle() {
		return this._title;
	} //-- java.lang.String getTitle()

	/**
	 * Method hasCascaded
	 */
	public boolean hasCascaded() {
		return this._has_cascaded;
	} //-- boolean hasCascaded()

	/**
	 * Method hasFixedHeight
	 */
	public boolean hasFixedHeight() {
		return this._has_fixedHeight;
	} //-- boolean hasFixedHeight()

	/**
	 * Method hasFixedWidth
	 */
	public boolean hasFixedWidth() {
		return this._has_fixedWidth;
	} //-- boolean hasFixedWidth()

	/**
	 * Method hasMaxScaleDenominator
	 */
	public boolean hasMaxScaleDenominator() {
		return this._has_maxScaleDenominator;
	} //-- boolean hasMaxScaleDenominator()

	/**
	 * Method hasMinScaleDenominator
	 */
	public boolean hasMinScaleDenominator() {
		return this._has_minScaleDenominator;
	} //-- boolean hasMinScaleDenominator()

	/**
	 * Method hasNoSubsets
	 */
	public boolean hasNoSubsets() {
		return this._has_noSubsets;
	} //-- boolean hasNoSubsets()

	/**
	 * Method hasOpaque
	 */
	public boolean hasOpaque() {
		return this._has_opaque;
	} //-- boolean hasOpaque()

	/**
	 * Method hasQueryable
	 */
	public boolean hasQueryable() {
		return this._has_queryable;
	} //-- boolean hasQueryable()

	/**
	 * Method removeAllAuthorityURL
	 */
	public void removeAllAuthorityURL() {
		_authorityURLList.removeAllElements();
	} //-- void removeAllAuthorityURL()

	/**
	 * Method removeAllBoundingBox
	 */
	/*
	 * public void removeAllBoundingBox() {
	 * _boundingBoxList.removeAllElements(); }
	 *///-- void removeAllBoundingBox()
	/**
	 * Method removeAllCRS
	 */
	/*
	 * public void removeAllCRS() { _CRSList.removeAllElements(); }
	 *///-- void removeAllCRS()
	/**
	 * Method removeAllDataURL
	 */
	public void removeAllDataURL() {
		_dataURLList.removeAllElements();
	} //-- void removeAllDataURL()

	/**
	 * Method removeAllDimension
	 */
	/*
	 * public void removeAllDimension() { _dimensionList.removeAllElements(); }
	 *///-- void removeAllDimension()
	/**
	 * Method removeAllFeatureListURL
	 */
	public void removeAllFeatureListURL() {
		_featureListURLList.removeAllElements();
	} //-- void removeAllFeatureListURL()

	/**
	 * Method removeAllIdentifier
	 */
	public void removeAllIdentifier() {
		_identifierList.removeAllElements();
	} //-- void removeAllIdentifier()

	/**
	 * Method removeAllLayer
	 */
	public void removeAllLayer() {
		_layerList.removeAllElements();
	} //-- void removeAllLayer()

	/**
	 * Method removeAllMetadataURL
	 */
	public void removeAllMetadataURL() {
		_metadataURLList.removeAllElements();
	} //-- void removeAllMetadataURL()

	/**
	 * Method removeAllStyle
	 */
	public void removeAllStyle() {
		_styleList.removeAllElements();
	} //-- void removeAllStyle()

	/**
	 * Method removeAuthorityURL
	 * 
	 * @param index
	 */
	public AuthorityURL removeAuthorityURL(int index) {
		java.lang.Object obj = _authorityURLList.elementAt(index);
		_authorityURLList.removeElementAt(index);
		return (AuthorityURL) obj;
	} //-- AuthorityURL removeAuthorityURL(int)

	/**
	 * Method removeBoundingBox
	 * 
	 * @param index
	 */
	/*
	 * public BoundingBox removeBoundingBox(int index) { java.lang.Object obj =
	 * _boundingBoxList.elementAt(index);
	 * _boundingBoxList.removeElementAt(index); return (BoundingBox) obj; }
	 *///-- BoundingBox removeBoundingBox(int)
	/**
	 * Method removeCRS
	 * 
	 * @param index
	 */
	public java.lang.String removeCRS(int index) {
		java.lang.Object obj = _CRSList.elementAt(index);
		_CRSList.removeElementAt(index);
		return (String) obj;
	} //-- java.lang.String removeCRS(int)

	/**
	 * Method removeDataURL
	 * 
	 * @param index
	 */
	public DataURL removeDataURL(int index) {
		java.lang.Object obj = _dataURLList.elementAt(index);
		_dataURLList.removeElementAt(index);
		return (DataURL) obj;
	} //-- DataURL removeDataURL(int)

	/**
	 * Method removeDimension
	 * 
	 * @param index
	 */
	/*
	 * public Dimension removeDimension(int index) { java.lang.Object obj =
	 * _dimensionList.elementAt(index); _dimensionList.removeElementAt(index);
	 * return (Dimension) obj; }
	 *///-- Dimension removeDimension(int)
	/**
	 * Method removeFeatureListURL
	 * 
	 * @param index
	 */
	public FeatureListURL removeFeatureListURL(int index) {
		java.lang.Object obj = _featureListURLList.elementAt(index);
		_featureListURLList.removeElementAt(index);
		return (FeatureListURL) obj;
	} //-- FeatureListURL removeFeatureListURL(int)

	/**
	 * Method removeIdentifier
	 * 
	 * @param index
	 */
	public Identifier removeIdentifier(int index) {
		java.lang.Object obj = _identifierList.elementAt(index);
		_identifierList.removeElementAt(index);
		return (Identifier) obj;
	} //-- Identifier removeIdentifier(int)

	/**
	 * Method removeLayer
	 * 
	 * @param index
	 */
	public Layer removeLayer(int index) {
		java.lang.Object obj = _layerList.elementAt(index);
		_layerList.removeElementAt(index);
		return (Layer) obj;
	} //-- Layer removeLayer(int)

	/**
	 * Method removeMetadataURL
	 * 
	 * @param index
	 */
	public MetadataURL removeMetadataURL(int index) {
		java.lang.Object obj = _metadataURLList.elementAt(index);
		_metadataURLList.removeElementAt(index);
		return (MetadataURL) obj;
	} //-- MetadataURL removeMetadataURL(int)

	/**
	 * Method removeStyle
	 * 
	 * @param index
	 */
	public Style removeStyle(int index) {
		java.lang.Object obj = _styleList.elementAt(index);
		_styleList.removeElementAt(index);
		return (Style) obj;
	} //-- Style removeStyle(int)

	/**
	 * Sets the value of field 'abstract'. The field 'abstract' has the
	 * following description: The abstract is a longer narrative description of
	 * an object.
	 * 
	 * 
	 * @param _abstract
	 * @param abstract
	 *            the value of field 'abstract'.
	 */
	public void setAbstract(java.lang.String _abstract) {
		this._abstract = _abstract;
	} //-- void setAbstract(java.lang.String)

	/**
	 * Sets the value of field 'attribution'. The field 'attribution' has the
	 * following description: Attribution indicates the provider of a Layer or
	 * collection of Layers. The provider's URL, descriptive title string,
	 * and/or logo image URL may be supplied. Client applications may choose to
	 * display one or more of these items. A format element indicates the MIME
	 * type of the logo image located at LogoURL. The logo image's width and
	 * height assist client applications in laying out space to display the
	 * logo.
	 * 
	 * 
	 * @param attribution
	 *            the value of field 'attribution'.
	 */
	public void setAttribution(Attribution attribution) {
		if (attribution == null)
			this._attribution = parent.getAttribution();
		else
			this._attribution = attribution;

	} //-- void setAttribution(Attribution)

	/**
	 * Method setAuthorityURL
	 * 
	 * @param index
	 * @param vAuthorityURL
	 */
	public void setAuthorityURL(int index, AuthorityURL vAuthorityURL)
			throws java.lang.IndexOutOfBoundsException {
		//-- check bounds for index
		if ((index < 0) || (index > _authorityURLList.size())) {
			throw new IndexOutOfBoundsException();
		}
		_authorityURLList.setElementAt(vAuthorityURL, index);
	} //-- void setAuthorityURL(int, AuthorityURL)

	/**
	 * Method setAuthorityURL
	 * 
	 * @param authorityURLArray
	 */
	public void setAuthorityURL(AuthorityURL[] authorityURLArray) {
		//-- copy array
		_authorityURLList.removeAllElements();
		for (int i = 0; i < authorityURLArray.length; i++) {
			_authorityURLList.addElement(authorityURLArray[i]);
		}
	} //-- void setAuthorityURL(AuthorityURL)

	/**
	 * Method setBoundingBox
	 * 
	 * @param index
	 * @param vBoundingBox
	 */
	/*
	 * public void setBoundingBox(int index, BoundingBox vBoundingBox) throws
	 * java.lang.IndexOutOfBoundsException { //-- check bounds for index if
	 * ((index < 0) || (index > _boundingBoxList.size())) { throw new
	 * IndexOutOfBoundsException(); }
	 * _boundingBoxList.setElementAt(vBoundingBox, index); }
	 *///-- void setBoundingBox(int, BoundingBox)
	/**
	 * Method setBoundingBox
	 * 
	 * @param boundingBoxArray
	 */
	public void setBoundingBox(BoundingBox[] boundingBoxArray) {
		//-- copy array

		for (int i = 0; i < boundingBoxArray.length; i++) {
			_boundingBoxList.put(boundingBoxArray[i].getCRS(),
					boundingBoxArray[i]);
		}
	} //-- void setBoundingBox(BoundingBox)

	/**
	 * Method setCRS
	 * 
	 * @param index
	 * @param vCRS
	 */
	public void setCRS(int index, java.lang.String vCRS)
			throws java.lang.IndexOutOfBoundsException {
		//-- check bounds for index
		if ((index < 0) || (index > _CRSList.size())) {
			throw new IndexOutOfBoundsException();
		}
		_CRSList.setElementAt(vCRS, index);
	} //-- void setCRS(int, java.lang.String)

	/**
	 * Method setCRS
	 * 
	 * @param CRSArray
	 */
	public void setCRS(java.lang.String[] CRSArray) {
		//-- copy array
		_CRSList.removeAllElements();
		for (int i = 0; i < CRSArray.length; i++) {
			_CRSList.addElement(CRSArray[i]);
		}
	} //-- void setCRS(java.lang.String)

	/**
	 * Sets the value of field 'cascaded'.
	 * 
	 * @param cascaded
	 *            the value of field 'cascaded'.
	 */
	public void setCascaded(int cascaded) {
		if (parent != null && cascaded == 0)
			this._cascaded = parent.getCascaded();
		else
			this._cascaded = cascaded;
		this._has_cascaded = true;
	} //-- void setCascaded(int)

	/**
	 * Method setDataURL
	 * 
	 * @param index
	 * @param vDataURL
	 */
	public void setDataURL(int index, DataURL vDataURL)
			throws java.lang.IndexOutOfBoundsException {
		//-- check bounds for index
		if ((index < 0) || (index > _dataURLList.size())) {
			throw new IndexOutOfBoundsException();
		}
		_dataURLList.setElementAt(vDataURL, index);
	} //-- void setDataURL(int, DataURL)

	/**
	 * Method setDataURL
	 * 
	 * @param dataURLArray
	 */
	public void setDataURL(DataURL[] dataURLArray) {
		//-- copy array
		_dataURLList.removeAllElements();
		for (int i = 0; i < dataURLArray.length; i++) {
			_dataURLList.addElement(dataURLArray[i]);
		}
	} //-- void setDataURL(DataURL)

	/**
	 * Method setDimension
	 * 
	 * @param index
	 * @param vDimension
	 */
	/*
	 * public void setDimension(int index, Dimension vDimension) throws
	 * java.lang.IndexOutOfBoundsException { //-- check bounds for index if
	 * ((index < 0) || (index > _dimensionList.size())) { throw new
	 * IndexOutOfBoundsException(); } _dimensionList.setElementAt(vDimension,
	 * index); }
	 *///-- void setDimension(int, Dimension)
	/**
	 * Method setDimension
	 * 
	 * @param dimensionArray
	 */
	public void setDimension(Dimension[] dimensionArray) {
		//-- copy array

		for (int i = 0; i < dimensionArray.length; i++) {
			_dimensionList.put(dimensionArray[i].getName(), dimensionArray[i]);
		}
	} //-- void setDimension(Dimension)

	/**
	 * Sets the value of field 'EX_GeographicBoundingBox'. The field
	 * 'EX_GeographicBoundingBox' has the following description: The
	 * EX_GeographicBoundingBox attributes indicate the edges of the enclosing
	 * rectangle in longitude and latitude decimal degrees.
	 * 
	 * 
	 * @param EX_GeographicBoundingBox
	 *            the value of field 'EX_GeographicBoundingBox'.
	 */
	public void setEX_GeographicBoundingBox(
			EX_GeographicBoundingBox EX_GeographicBoundingBox) {
		if (EX_GeographicBoundingBox == null && parent != null)
			this._EX_GeographicBoundingBox = parent
					.getEX_GeographicBoundingBox();
		else
			this._EX_GeographicBoundingBox = EX_GeographicBoundingBox;
	} //-- void setEX_GeographicBoundingBox(EX_GeographicBoundingBox)

	/**
	 * Method setFeatureListURL
	 * 
	 * @param index
	 * @param vFeatureListURL
	 */
	public void setFeatureListURL(int index, FeatureListURL vFeatureListURL)
			throws java.lang.IndexOutOfBoundsException {
		//-- check bounds for index
		if ((index < 0) || (index > _featureListURLList.size())) {
			throw new IndexOutOfBoundsException();
		}
		_featureListURLList.setElementAt(vFeatureListURL, index);
	} //-- void setFeatureListURL(int, FeatureListURL)

	/**
	 * Method setFeatureListURL
	 * 
	 * @param featureListURLArray
	 */
	public void setFeatureListURL(FeatureListURL[] featureListURLArray) {
		//-- copy array
		_featureListURLList.removeAllElements();
		for (int i = 0; i < featureListURLArray.length; i++) {
			_featureListURLList.addElement(featureListURLArray[i]);
		}
	} //-- void setFeatureListURL(FeatureListURL)

	/**
	 * Sets the value of field 'fixedHeight'.
	 * 
	 * @param fixedHeight
	 *            the value of field 'fixedHeight'.
	 */
	public void setFixedHeight(int fixedHeight) {
		if (parent != null && fixedHeight == 0)
			_fixedHeight = parent.getFixedHeight();
		else
			this._fixedHeight = fixedHeight;
		this._has_fixedHeight = true;
	} //-- void setFixedHeight(int)

	/**
	 * Sets the value of field 'fixedWidth'.
	 * 
	 * @param fixedWidth
	 *            the value of field 'fixedWidth'.
	 */
	public void setFixedWidth(int fixedWidth) {
		if (parent != null && fixedWidth == 0)
			_fixedWidth = parent.getFixedWidth();
		else
			this._fixedWidth = fixedWidth;
		this._has_fixedWidth = true;
	} //-- void setFixedWidth(int)

	/**
	 * Method setIdentifier
	 * 
	 * @param index
	 * @param vIdentifier
	 */
	public void setIdentifier(int index, Identifier vIdentifier)
			throws java.lang.IndexOutOfBoundsException {
		//-- check bounds for index
		if ((index < 0) || (index > _identifierList.size())) {
			throw new IndexOutOfBoundsException();
		}
		_identifierList.setElementAt(vIdentifier, index);
	} //-- void setIdentifier(int, Identifier)

	/**
	 * Method setIdentifier
	 * 
	 * @param identifierArray
	 */
	public void setIdentifier(Identifier[] identifierArray) {
		//-- copy array
		_identifierList.removeAllElements();
		for (int i = 0; i < identifierArray.length; i++) {
			_identifierList.addElement(identifierArray[i]);
		}
	} //-- void setIdentifier(Identifier)

	/**
	 * Sets the value of field 'keywordList'. The field 'keywordList' has the
	 * following description: List of keywords or keyword phrases to help
	 * catalog searching.
	 * 
	 * 
	 * @param keywordList
	 *            the value of field 'keywordList'.
	 */
	public void setKeywordList(KeywordList keywordList) {
		this._keywordList = keywordList;
	} //-- void setKeywordList(KeywordList)

	/**
	 * Method setLayer
	 * 
	 * @param index
	 * @param vLayer
	 */
	public void setLayer(int index, Layer vLayer)
			throws java.lang.IndexOutOfBoundsException {
		//-- check bounds for index
		if ((index < 0) || (index > _layerList.size())) {
			throw new IndexOutOfBoundsException();
		}
		_layerList.setElementAt(vLayer, index);
	} //-- void setLayer(int, Layer)

	/**
	 * Method setLayer
	 * 
	 * @param layerArray
	 */
	public void setLayer(Layer[] layerArray) {
		//-- copy array
		_layerList.removeAllElements();
		for (int i = 0; i < layerArray.length; i++) {
			_layerList.addElement(layerArray[i]);
		}
	} //-- void setLayer(Layer)

	/**
	 * Sets the value of field 'maxScaleDenominator'. The field
	 * 'maxScaleDenominator' has the following description: Maximum scale
	 * denominator for which it is appropriate to display this layer.
	 * 
	 * 
	 * @param maxScaleDenominator
	 *            the value of field 'maxScaleDenominator'.
	 */
	public void setMaxScaleDenominator(double maxScaleDenominator) {
		if (maxScaleDenominator == 0 && parent != null)
			this._maxScaleDenominator = this.parent.getMaxScaleDenominator();
		else
			this._maxScaleDenominator = maxScaleDenominator;

		this._has_maxScaleDenominator = true;
	} //-- void setMaxScaleDenominator(double)

	/**
	 * Method setMetadataURL
	 * 
	 * @param index
	 * @param vMetadataURL
	 */
	public void setMetadataURL(int index, MetadataURL vMetadataURL)
			throws java.lang.IndexOutOfBoundsException {
		//-- check bounds for index
		if ((index < 0) || (index > _metadataURLList.size())) {
			throw new IndexOutOfBoundsException();
		}
		_metadataURLList.setElementAt(vMetadataURL, index);
	} //-- void setMetadataURL(int, MetadataURL)

	/**
	 * Method setMetadataURL
	 * 
	 * @param metadataURLArray
	 */
	public void setMetadataURL(MetadataURL[] metadataURLArray) {
		//-- copy array
		_metadataURLList.removeAllElements();
		for (int i = 0; i < metadataURLArray.length; i++) {
			_metadataURLList.addElement(metadataURLArray[i]);
		}
	} //-- void setMetadataURL(MetadataURL)

	/**
	 * Sets the value of field 'minScaleDenominator'. The field
	 * 'minScaleDenominator' has the following description: Minimum scale
	 * denominator for which it is appropriate to display this layer.
	 * 
	 * 
	 * @param minScaleDenominator
	 *            the value of field 'minScaleDenominator'.
	 */
	public void setMinScaleDenominator(double minScaleDenominator) {
		this._minScaleDenominator = minScaleDenominator;
		this._has_minScaleDenominator = true;
	} //-- void setMinScaleDenominator(double)

	/**
	 * Sets the value of field 'name'. The field 'name' has the following
	 * description: The Name is typically for machine-to-machine communication.
	 * 
	 * 
	 * @param name
	 *            the value of field 'name'.
	 */
	public void setName(java.lang.String name) {
		this._name = name;
	} //-- void setName(java.lang.String)

	/**
	 * Sets the value of field 'noSubsets'.
	 * 
	 * @param noSubsets
	 *            the value of field 'noSubsets'.
	 */
	public void setNoSubsets(boolean noSubsets) {
		this._noSubsets = noSubsets;
		this._has_noSubsets = true;
	} //-- void setNoSubsets(boolean)

	/**
	 * Sets the value of field 'opaque'.
	 * 
	 * @param opaque
	 *            the value of field 'opaque'.
	 */
	public void setOpaque(boolean opaque) {
		this._opaque = opaque;
		this._has_opaque = true;
	} //-- void setOpaque(boolean)

	/**
	 * Sets the value of field 'queryable'.
	 * 
	 * @param queryable
	 *            the value of field 'queryable'.
	 */
	public void setQueryable(boolean queryable) {
		this._queryable = queryable;
		this._has_queryable = true;
	} //-- void setQueryable(boolean)

	/**
	 * Method setStyle
	 * 
	 * @param index
	 * @param vStyle
	 */
	public void setStyle(int index, Style vStyle)
			throws java.lang.IndexOutOfBoundsException {
		//-- check bounds for index
		if ((index < 0) || (index > _styleList.size())) {
			throw new IndexOutOfBoundsException();
		}
		_styleList.setElementAt(vStyle, index);
	} //-- void setStyle(int, Style)

	/**
	 * Method setStyle
	 * 
	 * @param styleArray
	 */
	public void setStyle(Style[] styleArray) {
		//-- copy array
		_styleList.removeAllElements();
		for (int i = 0; i < styleArray.length; i++) {
			_styleList.addElement(styleArray[i]);
		}
	} //-- void setStyle(Style)

	/**
	 * Sets the value of field 'title'. The field 'title' has the following
	 * description: The Title is for informative display to a human.
	 * 
	 * 
	 * @param title
	 *            the value of field 'title'.
	 */
	public void setTitle(java.lang.String title) {
		this._title = title;
	} //-- void setTitle(java.lang.String)

	/*
	 * Searches for the specific BoundingBox in the Layer.
	 */
	public BoundingBox searchForBoxWithCRS(String epsg) {
		Iterator iter = this.getBoundingBoxIterator();
		while (iter.hasNext()) {
			BoundingBox box = (BoundingBox) ((Map.Entry) iter.next())
					.getValue();
			if (box.getCRS().equalsIgnoreCase(epsg))
				return box;
		}
		return null;
	}
}