/*
 * This class was automatically generated with 
 * <a href="http://www.castor.org">Castor 0.9.5.2</a>, using an XML
 * Schema.
 * $Id: Style.java,v 1.1 2007/01/11 09:55:09 arne_broering Exp $
 */

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

package org.n52.wmsclientcore.capabilities.model;
import java.util.Vector;

import org.n52.wmsclientcore.capabilities.util.CapabilitiesElement;
import org.w3c.dom.Element;


/**
 * A Style element lists the name by which a style is requested and
 * a
 *  human-readable title for pick lists, optionally (and ideally)
 *  provides a human-readable description, and optionally gives a
 * style
 *  URL.
 *  
 * 
 * @version $Revision: 1.1 $ $Date: 2007/01/11 09:55:09 $
 */
public abstract class Style extends CapabilitiesElement implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * The Name is typically for machine-to-machine communication.
     *  
     */
    private java.lang.String _name;

    /**
     * The Title is for informative display to a human.
     *  
     */
    private java.lang.String _title;

    /**
     * The abstract is a longer narrative description of an object.
     *  
     */
    private java.lang.String _abstract;

    /**
     * A Map Server may use zero or more LegendURL elements to
     * provide an
     *  image(s) of a legend relevant to each Style of a Layer. The
     * Format
     *  element indicates the MIME type of the legend. Width and
     * height
     *  attributes may be provided to assist client applications in
     * laying out
     *  space to display the legend.
     *  
     */
    private java.util.Vector _legendURLList;

    /**
     * StyleSheeetURL provides symbology information foreach Style
     * of a Layer.
     *  
     */
    private StyleSheetURL _styleSheetURL;

    /**
     * A Map Server may use StyleURL to offer more information
     * about the
     *  data or symbology underlying a particular Style. While the
     * semantics
     *  are not well-defined, as long as the results of an HTTP GET
     * request
     *  against the StyleURL are properly MIME-typed, Viewer
     * Clients and
     *  Cascading Map Servers can make use of this. A possible use
     * could be
     *  to allow a Map Server to provide legend information.
     *  
     */
    private StyleURL _styleURL;


      //----------------/
     //- Constructors -/
    //----------------/

    public Style(Element elem) {
        super(elem);

    } //-- Style()
	protected void init(Element elem)
	{
		_legendURLList = new Vector();
	}

      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addLegendURL
     * 
     * @param vLegendURL
     */
    public void addLegendURL(LegendURL vLegendURL)
        throws java.lang.IndexOutOfBoundsException
    {
        _legendURLList.addElement(vLegendURL);
    } //-- void addLegendURL(LegendURL) 

    /**
     * Method addLegendURL
     * 
     * @param index
     * @param vLegendURL
     */
    public void addLegendURL(int index, LegendURL vLegendURL)
        throws java.lang.IndexOutOfBoundsException
    {
        _legendURLList.insertElementAt(vLegendURL, index);
    } //-- void addLegendURL(int, LegendURL) 

    /**
     * Method enumerateLegendURL
     */
    public java.util.Enumeration enumerateLegendURL()
    {
        return _legendURLList.elements();
    } //-- java.util.Enumeration enumerateLegendURL() 

    /**
     * Returns the value of field 'abstract'. The field 'abstract'
     * has the following description: The abstract is a longer
     * narrative description of an object.
     *  
     * 
     * @return the value of field 'abstract'.
     */
    public java.lang.String getAbstract()
    {
        return this._abstract;
    } //-- java.lang.String getAbstract() 

    /**
     * Method getLegendURL
     * 
     * @param index
     */
    public LegendURL getLegendURL(int index)
        throws java.lang.IndexOutOfBoundsException
    {
        //-- check bounds for index
        if ((index < 0) || (index > _legendURLList.size())) {
            throw new IndexOutOfBoundsException();
        }
        
        return (LegendURL) _legendURLList.elementAt(index);
    } //-- LegendURL getLegendURL(int) 

    /**
     * Method getLegendURL
     */
    public LegendURL[] getLegendURL()
    {
        int size = _legendURLList.size();
        LegendURL[] mArray = new LegendURL[size];
        for (int index = 0; index < size; index++) {
            mArray[index] = (LegendURL) _legendURLList.elementAt(index);
        }
        return mArray;
    } //-- LegendURL[] getLegendURL() 

    /**
     * Method getLegendURLCount
     */
    public int getLegendURLCount()
    {
        return _legendURLList.size();
    } //-- int getLegendURLCount() 

    /**
     * Returns the value of field 'name'. The field 'name' has the
     * following description: The Name is typically for
     * machine-to-machine communication.
     *  
     * 
     * @return the value of field 'name'.
     */
    public java.lang.String getName()
    {
        return this._name;
    } //-- java.lang.String getName() 

    /**
     * Returns the value of field 'styleSheetURL'. The field
     * 'styleSheetURL' has the following description:
     * StyleSheeetURL provides symbology information foreach Style
     * of a Layer.
     *  
     * 
     * @return the value of field 'styleSheetURL'.
     */
    public StyleSheetURL getStyleSheetURL()
    {
        return this._styleSheetURL;
    } //-- StyleSheetURL getStyleSheetURL() 

    /**
     * Returns the value of field 'styleURL'. The field 'styleURL'
     * has the following description: A Map Server may use StyleURL
     * to offer more information about the
     *  data or symbology underlying a particular Style. While the
     * semantics
     *  are not well-defined, as long as the results of an HTTP GET
     * request
     *  against the StyleURL are properly MIME-typed, Viewer
     * Clients and
     *  Cascading Map Servers can make use of this. A possible use
     * could be
     *  to allow a Map Server to provide legend information.
     *  
     * 
     * @return the value of field 'styleURL'.
     */
    public StyleURL getStyleURL()
    {
        return this._styleURL;
    } //-- StyleURL getStyleURL() 

    /**
     * Returns the value of field 'title'. The field 'title' has
     * the following description: The Title is for informative
     * display to a human.
     *  
     * 
     * @return the value of field 'title'.
     */
    public java.lang.String getTitle()
    {
        return this._title;
    } //-- java.lang.String getTitle() 

    /**
     * Method removeAllLegendURL
     */
    public void removeAllLegendURL()
    {
        _legendURLList.removeAllElements();
    } //-- void removeAllLegendURL() 

    /**
     * Method removeLegendURL
     * 
     * @param index
     */
    public LegendURL removeLegendURL(int index)
    {
        java.lang.Object obj = _legendURLList.elementAt(index);
        _legendURLList.removeElementAt(index);
        return (LegendURL) obj;
    } //-- LegendURL removeLegendURL(int) 

    /**
     * Sets the value of field 'abstract'. The field 'abstract' has
     * the following description: The abstract is a longer
     * narrative description of an object.
     *  
     * 
     * @param _abstract
     * @param abstract the value of field 'abstract'.
     */
    public void setAbstract(java.lang.String _abstract)
    {
        this._abstract = _abstract;
    } //-- void setAbstract(java.lang.String) 

    /**
     * Method setLegendURL
     * 
     * @param index
     * @param vLegendURL
     */
    public void setLegendURL(int index, LegendURL vLegendURL)
        throws java.lang.IndexOutOfBoundsException
    {
        //-- check bounds for index
        if ((index < 0) || (index > _legendURLList.size())) {
            throw new IndexOutOfBoundsException();
        }
        _legendURLList.setElementAt(vLegendURL, index);
    } //-- void setLegendURL(int, LegendURL) 

    /**
     * Method setLegendURL
     * 
     * @param legendURLArray
     */
    public void setLegendURL(LegendURL[] legendURLArray)
    {
        //-- copy array
        _legendURLList.removeAllElements();
        for (int i = 0; i < legendURLArray.length; i++) {
            _legendURLList.addElement(legendURLArray[i]);
        }
    } //-- void setLegendURL(LegendURL) 

    /**
     * Sets the value of field 'name'. The field 'name' has the
     * following description: The Name is typically for
     * machine-to-machine communication.
     *  
     * 
     * @param name the value of field 'name'.
     */
    public void setName(java.lang.String name)
    {
        this._name = name;
    } //-- void setName(java.lang.String) 

    /**
     * Sets the value of field 'styleSheetURL'. The field
     * 'styleSheetURL' has the following description:
     * StyleSheeetURL provides symbology information foreach Style
     * of a Layer.
     *  
     * 
     * @param styleSheetURL the value of field 'styleSheetURL'.
     */
    public void setStyleSheetURL(StyleSheetURL styleSheetURL)
    {
        this._styleSheetURL = styleSheetURL;
    } //-- void setStyleSheetURL(StyleSheetURL) 

    /**
     * Sets the value of field 'styleURL'. The field 'styleURL' has
     * the following description: A Map Server may use StyleURL to
     * offer more information about the
     *  data or symbology underlying a particular Style. While the
     * semantics
     *  are not well-defined, as long as the results of an HTTP GET
     * request
     *  against the StyleURL are properly MIME-typed, Viewer
     * Clients and
     *  Cascading Map Servers can make use of this. A possible use
     * could be
     *  to allow a Map Server to provide legend information.
     *  
     * 
     * @param styleURL the value of field 'styleURL'.
     */
    public void setStyleURL(StyleURL styleURL)
    {
        this._styleURL = styleURL;
    } //-- void setStyleURL(StyleURL) 

    /**
     * Sets the value of field 'title'. The field 'title' has the
     * following description: The Title is for informative display
     * to a human.
     *  
     * 
     * @param title the value of field 'title'.
     */
    public void setTitle(java.lang.String title)
    {
        this._title = title;
    } //-- void setTitle(java.lang.String) 

}
