/*
 * This class was automatically generated with 
 * <a href="http://www.castor.org">Castor 0.9.5.2</a>, using an XML
 * Schema.
 * $Id: OperationType.java,v 1.1 2007/01/11 09:55:19 arne_broering Exp $
 */

//---------------------------------/
//- Imported classes and packages -/
//---------------------------------/
package org.n52.wmsclientcore.capabilities.model.types;

import java.util.Iterator;
import java.util.Vector;

import org.n52.wmsclientcore.capabilities.util.CapabilitiesElement;
import org.w3c.dom.Element;


/**
 * For each operation offered by the server, list the available output formats
 * and the online resource.
 * 
 * 
 * @version $Revision: 1.1 $ $Date: 2007/01/11 09:55:19 $
 */
public abstract class OperationType extends CapabilitiesElement implements
        java.io.Serializable {

    //--------------------------/
    //- Class/Member Variables -/
    //--------------------------/

    /**
     * A container for listing an available format's MIME type.
     *  
     */
    private java.util.Vector _formatList;

    /**
     * Available Distributed Computing Platforms (DCPs) are listed here. At
     * present, only HTTP is defined.
     *  
     */
    private java.util.Vector _DCPTypeList;

    //----------------/
    //- Constructors -/
    //----------------/

    public OperationType(Element elem) {
        super(elem);

    } //-- OperationType()

    //-----------/
    //- Methods -/
    //-----------/

    /**
     * Method addDCPType
     * 
     * @param vDCPType
     */
    public void addDCPType(DCPType vDCPType)
            throws java.lang.IndexOutOfBoundsException {
        _DCPTypeList.addElement(vDCPType);
    } //-- void addDCPType(DCPType)

    /**
     * Method addDCPType
     * 
     * @param index
     * @param vDCPType
     */
    public void addDCPType(int index, DCPType vDCPType)
            throws java.lang.IndexOutOfBoundsException {
        _DCPTypeList.insertElementAt(vDCPType, index);
    } //-- void addDCPType(int, DCPType)

    /**
     * Method addFormat
     * 
     * @param vFormat
     */
    public void addFormat(java.lang.String vFormat)
            throws java.lang.IndexOutOfBoundsException {
        _formatList.addElement(vFormat);
    } //-- void addFormat(java.lang.String)

    /**
     * Method addFormat
     * 
     * @param index
     * @param vFormat
     */
    public void addFormat(int index, java.lang.String vFormat)
            throws java.lang.IndexOutOfBoundsException {
        _formatList.insertElementAt(vFormat, index);
    } //-- void addFormat(int, java.lang.String)

    /**
     * Method enumerateDCPType
     */
    public java.util.Enumeration enumerateDCPType() {
        return _DCPTypeList.elements();
    } //-- java.util.Enumeration enumerateDCPType()

    /**
     * Method enumerateFormat
     */
    public java.util.Enumeration enumerateFormat() {
        return _formatList.elements();
    } //-- java.util.Enumeration enumerateFormat()

    /**
     * Method getDCPType
     * 
     * @param index
     */
    public DCPType getDCPType(int index)
            throws java.lang.IndexOutOfBoundsException {
        //-- check bounds for index
        if ((index < 0) || (index > _DCPTypeList.size())) {
            throw new IndexOutOfBoundsException();
        }

        return (DCPType) _DCPTypeList.elementAt(index);
    } //-- DCPType getDCPType(int)

    /**
     * Method getDCPType
     */
    public DCPType[] getDCPType() {
        int size = _DCPTypeList.size();
        DCPType[] mArray = new DCPType[size];
        for (int index = 0; index < size; index++) {
            mArray[index] = (DCPType) _DCPTypeList.elementAt(index);
        }
        return mArray;
    } //-- DCPType[] getDCPType()

    /**
     * Method getDCPTypeCount
     */
    public int getDCPTypeCount() {
        return _DCPTypeList.size();
    } //-- int getDCPTypeCount()

    /**
     * Method getFormat
     * 
     * @param index
     */
    public java.lang.String getFormat(int index)
            throws java.lang.IndexOutOfBoundsException {
        //-- check bounds for index
        if ((index < 0) || (index > _formatList.size())) {
            throw new IndexOutOfBoundsException();
        }

        return (String) _formatList.elementAt(index);
    } //-- java.lang.String getFormat(int)

    /**
     * Method getFormat
     */
    public java.lang.String[] getFormat() {
        int size = _formatList.size();
        java.lang.String[] mArray = new java.lang.String[size];
        for (int index = 0; index < size; index++) {
            mArray[index] = (String) _formatList.elementAt(index);
        }
        return mArray;
    } //-- java.lang.String[] getFormat()

    /**
     * Method getFormatCount
     */
    public int getFormatCount() {
        return _formatList.size();
    } //-- int getFormatCount()

    /**
     * Method removeAllDCPType
     */
    public void removeAllDCPType() {
        _DCPTypeList.removeAllElements();
    } //-- void removeAllDCPType()

    /**
     * Method removeAllFormat
     */
    public void removeAllFormat() {
        _formatList.removeAllElements();
    } //-- void removeAllFormat()

    /**
     * Method removeDCPType
     * 
     * @param index
     */
    public DCPType removeDCPType(int index) {
        java.lang.Object obj = _DCPTypeList.elementAt(index);
        _DCPTypeList.removeElementAt(index);
        return (DCPType) obj;
    } //-- DCPType removeDCPType(int)

    /**
     * Method removeFormat
     * 
     * @param index
     */
    public java.lang.String removeFormat(int index) {
        java.lang.Object obj = _formatList.elementAt(index);
        _formatList.removeElementAt(index);
        return (String) obj;
    } //-- java.lang.String removeFormat(int)

    /**
     * Method setDCPType
     * 
     * @param index
     * @param vDCPType
     */
    public void setDCPType(int index, DCPType vDCPType)
            throws java.lang.IndexOutOfBoundsException {
        //-- check bounds for index
        if ((index < 0) || (index > _DCPTypeList.size())) {
            throw new IndexOutOfBoundsException();
        }
        _DCPTypeList.setElementAt(vDCPType, index);
    } //-- void setDCPType(int, DCPType)

    /**
     * Method setDCPType
     * 
     * @param DCPTypeArray
     */
    public void setDCPType(DCPType[] DCPTypeArray) {
        //-- copy array
        _DCPTypeList.removeAllElements();
        for (int i = 0; i < DCPTypeArray.length; i++) {
            _DCPTypeList.addElement(DCPTypeArray[i]);
        }
    } //-- void setDCPType(DCPType)

    /**
     * Method setFormat
     * 
     * @param index
     * @param vFormat
     */
    public void setFormat(int index, java.lang.String vFormat)
            throws java.lang.IndexOutOfBoundsException {
        //-- check bounds for index
        if ((index < 0) || (index > _formatList.size())) {
            throw new IndexOutOfBoundsException();
        }
        _formatList.setElementAt(vFormat, index);
    } //-- void setFormat(int, java.lang.String)

    /**
     * Method setFormat
     * 
     * @param formatArray
     */
    public void setFormat(java.lang.String[] formatArray) {
        //-- copy array
        _formatList.removeAllElements();
        for (int i = 0; i < formatArray.length; i++) {
            _formatList.addElement(formatArray[i]);
        }
    } //-- void setFormat(java.lang.String)

    /*
     * (non-Javadoc)
     * 
     * @see de.ifgi.wms.capabilities.util.CapabilitiesElement#init(org.dom4j.Element)
     */
    protected void init(Element elem) {
        _formatList = new Vector();
        _DCPTypeList = new Vector();

    }

    /**
     * checks if the operation supports a given return format.
     * 
     * @param format
     *            the mine/type
     * @return boolean true if format is supported. else false.
     */
    public boolean supportsFormat(String format) {
        for (Iterator iter = _formatList.iterator(); iter.hasNext();) {
            if (((String) iter.next()).equals(format))
                return true;
        }
        return false;
    }
}