/*
 * Created on 18.11.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.n52.wmsclientcore.capabilities.version100;

import java.util.StringTokenizer;

import org.n52.wmsclientcore.capabilities.util.CapabilitiesElement;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;


/**
 * @author tfoerste
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Layer extends org.n52.wmsclientcore.capabilities.model.Layer implements ICapabilitiesElement100{
	ScaleHint scaleHint;
	/**
	 * 
	 */
	public Layer(Element elem)
	{
		super(elem);
	}
	public Layer(Element elem, Layer parent) {
		super(elem,parent);
	}
	private void setLayers(Element elem) {
		NodeList list = elem.getElementsByTagName("Layer");
		for (int i = 0; i<list.getLength(); i++) {
			this.addLayer(new Layer((Element) list.item(i), this));
        }
	}
	private void setStyles(Element elem) {
		NodeList list = elem.getElementsByTagName("Style");
		for(int i = 0; i < list.getLength(); i++) {
			this.addStyle(new Style((Element) list.item(i)));
        }
	}
	private void setBoundingBox(Element elem){

		NodeList list = elem.getElementsByTagName("BoundingBox");
		for(int i = 0; i<list.getLength(); i++) {
			this.addBoundingBox(new BoundingBox((Element) list.item(i)));
        }
	}
	private void setQueryable(Element elem) {
		String value = elem.getAttribute("queryable");
        this.setQueryable((value!= null && value.equals("1"))? true:false);
	}
	/*
	 * Sets the SRS. It s needy, cause there is a (syntactic) mismatch between 1.0 and 1.2.
	*/
	private void setSRS(Element elem) {
		String srs = this.getParsedData("SRS", elem);
		if (srs != null) {
			StringTokenizer tok = new StringTokenizer(srs, " ");

			while (tok.hasMoreElements()) {
				String srsTok = (String) tok.nextElement();
				// PERHAPS BLANKS HAVE TO BE ELIMITATED
				this.addCRS(srsTok);
			}
		}
	}
	/* (non-Javadoc)
	 * @see de.ifgi.wms.capabilities.util.CapabilitiesElement#init(org.dom4j.Element)
	 */
	protected void init(Element elem) {
		super.init();
		this.setTitle(this.getParsedData("Title", elem));
		this.setName(this.getParsedData("Name", elem));
		this.setAbstract(this.getParsedData("Abstract", elem));
		this.setKeywordList(new Keywords((Element)elem.getElementsByTagName("Keywords").item(0)));
		this.setSRS(elem);
		this.setEX_GeographicBoundingBox(new LatLonBoundingBox((Element)elem.getElementsByTagName("LatLonBoundingBox").item(0)));
		this.setQueryable(elem);
		this.setBoundingBox(elem);
		this.addDataURL(new DataURL((Element)elem.getElementsByTagName("DataURL").item(0)));
		this.setStyles(elem);
		this.setScaleHint(new ScaleHint((Element)elem.getElementsByTagName("ScaleHint").item(0)));
		this.setLayers(elem);

	}
	public void setScaleHint(ScaleHint hint) {
		this.scaleHint = hint;
	}

	private class ScaleHint extends CapabilitiesElement implements ICapabilitiesElement100 {
		private double min, max;
		/**
		 * @param elem
		 */
		public ScaleHint(Element elem) {
			super(elem);
			

		}

		/* (non-Javadoc)
		 * @see de.ifgi.wms.capabilities.util.CapabilitiesElement#init(org.dom4j.Element)
		 */
		protected void init(Element elem) {
			this.setMin(Double.parseDouble(this.getAttributeData("min", null, elem)));
			this.setMax(Double.parseDouble(this.getAttributeData("max", null, elem)));
		}
		/**
		 * @return
		 */
		public double getMax() {
			return max;
		}

		/**
		 * @return
		 */
		public double getMin() {
			return min;
		}

		/**
		 * @param d
		 */
		public void setMax(double d) {
			max = d;
		}

		/**
		 * @param d
		 */
		public void setMin(double d) {
			min = d;
		}

		/* (non-Javadoc)
		 * @see de.ifgi.wms.capabilities.util.ICapabilitiesElement#setVersionID()
		 */
		protected void setVersionID() {
			this.versionId = internID;
			
		}

	}
	/* (non-Javadoc)
	 * @see de.ifgi.wms.capabilities.model.Layer#getMaxScaleDenominator()
	 */
	public double getMaxScaleDenominator() {

		return this.scaleHint.getMax();
	}

	/* (non-Javadoc)
	 * @see de.ifgi.wms.capabilities.model.Layer#getMinScaleDenominator()
	 */
	public double getMinScaleDenominator() {

		return this.scaleHint.getMin();
	}
	/* (non-Javadoc)
	 * @see de.ifgi.wms.capabilities.util.ICapabilitiesElement#setVersionID()
	 */
	protected void setVersionID() {
		this.versionId = internID;
		
	}
	//Extent is not part of the 1.0.0 spec.
	protected void initExtent()
	{
		
	}

}
