/*
 * Created on 18.11.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.n52.wmsclientcore.capabilities.version111;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.StringTokenizer;

import org.n52.wmsclientcore.capabilities.util.CapabilitiesElement;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;


/**
 * @author tfoerste
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Layer extends org.n52.wmsclientcore.capabilities.model.Layer implements
		ICapabilitiesElement111 {
	ScaleHint scaleHint;

	private ArrayList<Extent> extents;

	/**
	 *  
	 */

	public Layer(Element elem) {
		super(elem);

	}

	public Layer(Element elem, Layer parent) {
		super(elem, parent);
	}

	protected void setVersionID() {
		this.versionId = internID;

	}

	private void setLayers(Element elem) {
		NodeList list = elem.getElementsByTagName("Layer");
		for(int i = 0; i<list.getLength(); i++) {
			this.addLayer(new Layer((Element) list.item(i), this));
        }
	}

	private void setStyles(Element elem) {
		NodeList list = elem.getElementsByTagName("Style");
		for(int i = 0; i<list.getLength(); i++) {
			this.addStyle(new Style((Element) list.item(i)));
        }
	}

	private void setBoundingBox(Element elem) {

		NodeList list = elem.getElementsByTagName("BoundingBox");
		for(int i = 0; i<list.getLength(); i++)
			this.addBoundingBox(new BoundingBox((Element) list.item(i)));

	}

	private void setQueryable(Element elem) {
		String value = elem.getAttribute("queryable");
		setQueryable((!value.equals("") && value.equals("1"))?true:false);
	}

	private void setCascaded(Element elem) {
		String value = elem.getAttribute("cascaded");
		if (!value.equals(""))
			this.setCascaded(Integer.parseInt(value));
	}

	private void setOpaque(Element elem) {
		String value = elem.getAttribute("opaque");
		this.setOpaque((!value.equals("") && value.equals("1")) ? true : false);
	}

	private void setNoSubsets(Element elem) {
		String value = elem.getAttribute("noSubsets");
		this.setNoSubsets((!value.equals("") && value.equals("1")) ? true : false);
	}

	private void setFixedWidth(Element elem) {
		String value = elem.getAttribute("fixedWidth");
		if (!value.equals(""))
			this.setFixedWidth(Integer.parseInt(value));
	}

	private void setFixedHeight(Element elem) {
		String value = elem.getAttribute("fixedHeight");
		if (!value.equals(""))
			this.setFixedWidth(Integer.parseInt(value));
	}

	/*
	 * Sets the SRS. It s needy, cause there is a (syntactic) mismatch between
	 * 1.0 and 1.2.
	 */
	private void setSRS(Element elem) {
		NodeList list = elem.getElementsByTagName("SRS");
		for(int i = 0; i<list.getLength(); i++){
			String srs = list.item(i).getTextContent();
			if (srs != null) {
				StringTokenizer tok = new StringTokenizer(srs, " ");
				while (tok.hasMoreElements()) {
					String srsTok = (String) tok.nextElement();
					// PERHAPS BLANKS HAVE TO BE ELIMITATED
					this.addCRS(srsTok);
				}
			}
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see de.ifgi.wms.capabilities.util.CapabilitiesElement#init(org.dom4j.Element)
	 */
	protected void init(Element elem) {
		super.init();
		extents = new ArrayList();
		this.setTitle(this.getParsedData("Title", elem));
		this.setName(this.getParsedData("Name", elem));
		this.setAbstract(this.getParsedData("Abstract", elem));
		this.setKeywordList(new KeywordList((Element)elem.getElementsByTagName("KeywordList").item(0)));
		this.setSRS(elem);
		this.setEX_GeographicBoundingBox(
                new LatLonBoundingBox(
                        (Element)elem.getElementsByTagName("LatLonBoundingBox").item(0))
                        );
		this.setBoundingBox(elem);
		this.setDimension(elem);
		//EXTENT LEFT OUT!
		this.setAttribution(new Attribution((Element)elem.getElementsByTagName("Attribution").item(0)));
		this.setAuthorityURL(elem);
		this.setIdentifier(elem);
		this.setMetadataURL(elem);
		this.setDataURL(elem);
		this.setFeatureListURL(elem);
		this.setStyles(elem);
		this.setScaleHint(new ScaleHint((Element)elem.getElementsByTagName("ScaleHint").item(0)));
		this.setLayers(elem);
		/*
		 * SET-ATTRIBUTE SECTION
		 */
		this.setQueryable(elem);
		this.setCascaded(elem);
		this.setOpaque(elem);
		this.setFixedHeight(elem);
		this.setFixedWidth(elem);
		this.setNoSubsets(elem);
		this.initExtentList(elem);

	}

	private void initExtentList(Element elem) {
		NodeList list = elem.getElementsByTagName("Extent");
		if (list != null) {
			for (int i = 0; i<list.getLength(); i++) {
				extents.add(new Extent((Element) list.item(i)));
            }
		}
	}

	private class Extent {
		private String name, content, defaultValue;

		public Extent(Element elem) {
			name = elem.getAttribute("name");
			content = elem.getTextContent();
			defaultValue = elem.getAttribute("default");
		}

		/**
		 * @return Returns the content.
		 */
		public String getContent() {
			return content;
		}

		/**
		 * @return Returns the defaultValue.
		 */
		public String getDefaultValue() {
			return defaultValue;
		}

		/**
		 * @return Returns the name.
		 */
		public String getName() {
			return name;
		}

	}

	/**
	 * this will be called after initialization... and after inheriting
	 * attributes!
	 */
	protected void initExtent() {
		for (Iterator iter = this.extents.iterator(); iter.hasNext();) {
			Extent extent = (Extent) iter.next();
			if (this.dimensionExists(extent.getName())) {
				this.getDimensionByName(extent.getName()).setContent(
						extent.getContent());
				this.getDimensionByName(extent.getName()).setDefault(
						extent.getDefaultValue());
			}
		}
	}

	/**
	 * @param elem
	 */
	private void setFeatureListURL(Element elem) {
		NodeList list = elem.getElementsByTagName("FeatureListURL");
		for(int i = 0; i<list.getLength(); i++) {
			this.addFeatureListURL(new FeatureListURL((Element) list.item(i)));
        }

	}

	/**
	 * @param elem
	 */
	private void setDataURL(Element elem) {
		NodeList list = elem.getElementsByTagName("DataURL");
		for(int i = 0; i<list.getLength(); i++) {
			this.addDataURL(new DataURL((Element) list.item(i)));
        }
	}

	/**
	 * @param elem
	 */
	private void setMetadataURL(Element elem) {
		NodeList list = elem.getElementsByTagName("MetadataURL");
		for(int i = 0; i<list.getLength(); i++) {
			this.addMetadataURL(new MetadataURL((Element) list.item(i)));
        }
	}

	/**
	 * @param elem
	 */
	private void setIdentifier(Element elem) {
		NodeList list = elem.getElementsByTagName("Identifier");
		for(int i = 0; i<list.getLength(); i++){
			this.addIdentifier(new Identifier((Element) list.item(0)));
		}

	}

	private void setAuthorityURL(Element elem) {
		NodeList list = elem.getElementsByTagName("AuthorityURL");
		for(int i = 0; i<list.getLength(); i++){
			this.addAuthorityURL(new AuthorityURL((Element) list.item(i)));
		}
	}

	private void setDimension(Element elem) {
		NodeList list = elem.getElementsByTagName("Dimension");
		for(int i = 0; i<list.getLength(); i++){
			this.addDimension(new Dimension((Element) list.item(i)));
		}

	}

	private void setScaleHint(ScaleHint hint) {
		this.scaleHint = hint;
	}

	private class ScaleHint extends CapabilitiesElement implements
			ICapabilitiesElement111 {
		private double min, max;

		/**
		 * @param elem
		 */
		public ScaleHint(Element elem) {
			super(elem);
		}

		/*
		 * (non-Javadoc)
		 * 
		 * @see de.ifgi.wms.capabilities.util.CapabilitiesElement#init(org.dom4j.Element)
		 */
		protected void init(Element elem) {
			String minStr = this.getAttributeData("min", null, elem);
			if (minStr.equals(""))
				minStr = "0";
			String maxStr = this.getAttributeData("max", null, elem);
			if (maxStr.equals(""))
				maxStr = "0";
			this.setMin(Double.parseDouble(minStr));
			this.setMax(Double.parseDouble(maxStr));
		}

		protected void setVersionID() {
			this.versionId = internID;

		}

		/**
		 * @return
		 */
		public double getMax() {
			return max;
		}

		/**
		 * @return
		 */
		public double getMin() {
			return min;
		}

		/**
		 * @param d
		 */
		public void setMax(double d) {
			max = d;
		}

		/**
		 * @param d
		 */
		public void setMin(double d) {
			min = d;
		}

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see de.ifgi.wms.capabilities.model.Layer#getMaxScaleDenominator()
	 */
	public double getMaxScaleDenominator() {

		return this.scaleHint.getMax();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see de.ifgi.wms.capabilities.model.Layer#getMinScaleDenominator()
	 */
	public double getMinScaleDenominator() {

		return this.scaleHint.getMin();
	}

}