/*
 * Created on 04.12.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.n52.wmsclientcore.request;

import org.n52.wmsclientcore.*;

/**
 * @author tfoerste
 *
 */
public abstract class GetMapRequest extends Request {

	/*
	 * CONSTANTS
	 */
	protected String VERSIONPARAMVALUE;
	protected String VERSIONPARAMNAME;
	protected String REQUESTPARAMVALUE;
	protected String SERVICEPARAMNAME = "SERVICE";
	protected String REQUESTPARAMNAME = "REQUEST";
	protected String LAYERSPARAMNAME = "LAYERS";
	protected String STYLESPARAMNAME = "STYLES";
	protected String CRSPARAMNAME;
	protected String BBOXPARAMNAME = "BBOX";
	protected String WIDTHPARAMNAME = "WIDTH";
	protected String HEIGHTPARAMNAME = "HEIGHT";
	protected String FORMATPARAMNAME = "FORMAT";
	protected String TRANSPARENTPARAMNAME = "TRANSPARENT";
	protected String BGCOLORPARAMNAME = "BGCOLOR";
	protected String EXCEPTIONSPARAMNAME = "EXCEPTIONS";
	protected String TIMEPARAMNAME = "TIME";
	
	//IONIC Specific CPS Parameter
	
	protected String SLDPARAMNAME = "SLD";
	
	
	/*
	 * request parameters, some optional values are not set!
	 */
	private String format, crs, request, height, width,time,sld;
	private String styles = new String("");
	private String layers = new String("");
	private RequestBoundingBox bbox;
	private boolean transparent;
	/**
	 * 
	 */

	public GetMapRequest(String url) {
		super(url);

	}

	/**
	 * @return
	 */
	public RequestBoundingBox getBbox() {
		return bbox;
	}

	/**
	 * @return
	 */
	public String getCrs() {
		return crs;
	}

	/**
	 * @return
	 */
	public String getFormat() {
		return format;
	}

	/**
	 * @return
	 */
	public String getHeight() {
		return height;
	}

	/**
	 * @return
	 */
	public String getLayers() {
		return layers;
	}

	/**
	 * @return
	 */
	public String getRequest() {
		return request;
	}

	/**
	 * @return
	 */
	public String getStyles() {
		return styles;
	}

	/**
	 * @return
	 */
	public String getWidth() {
		return width;
	}

	/**
	 * @param string
	 */
	public void setBbox(RequestBoundingBox box) {
		bbox = box;
		this.setCrs(box.getSrs());
	}

	/**
	 * @param string
	 */
	public void setCrs(String string) {
		crs = string;
	}

	/**
	 * @param string
	 */
	public void setFormat(String string) {
		format = string;
	}

	/**
	 * @param string
	 */
	public void setHeight(String string) {
		height = string;
	}

	/**
	 * @param string
	 */
	public void setLayers(String string) {
		layers = string;
	}

	/**
	 * @param string
	 */
	public void setRequest(String string) {
		request = string;
	}

	/**
	 * @param string
	 */
	public void setStyles(String string) {
		styles = string;
	}

	/**
	 * @param string
	 */
	public void setWidth(String string) {
		width = string;
	}

	/**
	 * @return
	 */
	public boolean isTransparent() {
		return transparent;
	}

	/**
	 * @param b
	 */
	public void setTransparent(boolean b) {
		transparent = b;
	}
	public void addLayer(String name) {
		if (layers.equals(""))
			layers = name;
		else
			layers = layers + "," + name;
	}
	public void insertLayerBefore(String name) {
		if(layers==null)
			layers = name;
		else if (layers.equals(""))
			layers = name;
		else
			layers = name + "," + layers;
	}
	public void insertStyleBefore(String style) {
		if(styles==null)
			styles = style;
		else if (styles.equals(""))
			styles = style;
		else
			styles = style + "," + styles;
	}
	public void addStyle(String style) {
		if (styles.equals(""))
			styles = style;
		else
			styles = styles + "," + style;
	}
	public abstract String getPartialRequest();
	/**
	 * @return
	 */
	public String getTime() {
		return time;
	}

	/**
	 * @param string
	 */
	public void setTime(String string) {
		time = string;
	}

	/**
	 * @return Returns the sld.
	 */
	public String getSld() {
		return sld;
	}
	/**
	 * @param sld The sld to set.
	 */
	public void setSld(String sld) {
		this.sld = sld;
	}
}
