/*
 * Created on 08.02.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.n52.wmsclientcore.util;

import java.io.IOException;
import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 * 
 * This class analyzes SLD documents. 
 * It extracts only some information and should be replaced by a sophisticated parser 
 * within a redesign phase.
 * @author tfoerste
 *
 */
public class SLDAnalyser {
	String url;
	Document document;
	public SLDAnalyser(Document doc)
	{
		document = doc;
	}
    public SLDAnalyser(String url)
	{
    	this.url = url;
		try {
            init();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (SAXException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
	}
    private void init()throws IOException, SAXException {
        
        try {
            document = DocumentBuilderFactory.newInstance().newDocumentBuilder().parse(url);
        }
        catch(ParserConfigurationException e){
            
        }
        
        
    }
    public String getSLDName()
    {
        String sldName = document.getDocumentElement().getElementsByTagName("Name").item(0).getNodeValue();
    	return (sldName == null)? null : sldName; 
    }
    public String getSLDTitle()
    {
    	return document.getDocumentElement().getElementsByTagName("Title").item(0).getNodeValue();
    }
    public static void main(String[] args)
    {
    	
    	SLDAnalyser analyser = new SLDAnalyser ("http://triangulum:8080/CPS_SLD.xml");
    	System.out.println(analyser.getSLDTitle());
    }
    /**
     * extracts a given number of colors out of the colormap and encodes them for HTTP-GET
     * @param i the number of colors (i>2)
     * @return 
     */
    public ArrayList getColors(int numberOfColors)
    {
    	ArrayList<String> colorStrings = new ArrayList<String>();
    	Element colorMapElem = (Element)((Element)((Element)((Element)((Element)((Element)document.getDocumentElement().getElementsByTagName("UserLayer").item(0)).getElementsByTagName("UserStyle").item(0)).getElementsByTagName("FeatureTypeStyle").item(0)).getElementsByTagName("Rule").item(0)).getElementsByTagName("RasterSymbolizer").item(0)).getElementsByTagName("ColorMap").item(0);
    	NodeList colorMapEntrys = colorMapElem.getElementsByTagName("*");
    	colorStrings.add(((Element)colorMapEntrys.item(0)).getAttribute("color").replaceAll("#","%23"));
    	int numberOfLeftColors = colorMapEntrys.getLength()-2;
    	int step = numberOfLeftColors/numberOfColors;
    	if(step < 1)
        {
         step = 1;   
        }
    	for(int i= 1; i<colorMapEntrys.getLength();)
    	{
    		Element elem = (Element)colorMapEntrys.item(i);
    		String color = elem.getAttribute("color");
			color = color.replaceAll("#", "%23");
    		colorStrings.add(color);
    		i = i + step;
    	}
        if(colorMapEntrys.getLength() > numberOfColors)
    	{
            colorStrings.add(((Element)colorMapEntrys.item(numberOfColors-1)).getAttribute("color").replaceAll("#","%23"));
        }
    	return colorStrings;
	}
    
    public ArrayList getAllColors()
    {
        ArrayList<String> colors = new ArrayList<String>();
        Element colorMapElem = (Element)((Element)((Element)((Element)((Element)((Element)document.getDocumentElement().getElementsByTagName("UserLayer").item(0)).getElementsByTagName("UserStyle").item(0)).getElementsByTagName("FeatureTypeStyle").item(0)).getElementsByTagName("Rule").item(0)).getElementsByTagName("RasterSymbolizer").item(0)).getElementsByTagName("ColorMap").item(0);
        NodeList colorMapEntrys = colorMapElem.getElementsByTagName("*");
        for(int i = 0; i<colorMapEntrys.getLength();i++)
        {
            colors.add(((Element)colorMapEntrys.item(i)).getAttribute("color"));
        }
        return colors;
    }
    public double getMinOfColorMap()
    {
        Element colorMapElem = (Element)((Element)((Element)((Element)((Element)((Element)document.getDocumentElement().getElementsByTagName("UserLayer").item(0)).getElementsByTagName("UserStyle").item(0)).getElementsByTagName("FeatureTypeStyle").item(0)).getElementsByTagName("Rule").item(0)).getElementsByTagName("RasterSymbolizer").item(0)).getElementsByTagName("ColorMap").item(0);
    	NodeList colorMapEntrys = colorMapElem.getElementsByTagName("*");
    	double minValue = Double.parseDouble(((Element)colorMapEntrys.item(0)).getAttribute("quantity"));
    	for(int i = 1; i< colorMapEntrys.getLength(); i++)
    	{
    		if(Double.parseDouble(((Element)colorMapEntrys.item(i)).getAttribute("quantity")) < minValue)
    			minValue = Double.parseDouble(((Element)colorMapEntrys.item(i)).getAttribute("quantity"));
    		
    	}
    	return minValue;
    }
    
    /**
     * retrieves the quantity value of the last element.
     * @return
     */
    public double getLastValueOfColorMap()
    {
        Element colorMapElem = (Element)((Element)((Element)((Element)((Element)((Element)document.getDocumentElement().getElementsByTagName("UserLayer").item(0)).getElementsByTagName("UserStyle").item(0)).getElementsByTagName("FeatureTypeStyle").item(0)).getElementsByTagName("Rule").item(0)).getElementsByTagName("RasterSymbolizer").item(0)).getElementsByTagName("ColorMap").item(0);
    	NodeList colorMapEntrys = colorMapElem.getElementsByTagName("*");
    	return Double.parseDouble(((Element)colorMapEntrys.item((colorMapEntrys.getLength()-1))).getAttribute("quantity"));
    }
    
    /**
     * retrieves the quanitity value of the first element.
     * @return
     */
    public double getFirstValueOfColorMap()
    {
        Element colorMapElem = (Element)((Element)((Element)((Element)((Element)((Element)document.getDocumentElement().getElementsByTagName("UserLayer").item(0)).getElementsByTagName("UserStyle").item(0)).getElementsByTagName("FeatureTypeStyle").item(0)).getElementsByTagName("Rule").item(0)).getElementsByTagName("RasterSymbolizer").item(0)).getElementsByTagName("ColorMap").item(0);
    	NodeList colorMapEntrys = colorMapElem.getElementsByTagName("*");
    	return Double.parseDouble(((Element)colorMapEntrys.item((0))).getAttribute("quantity"));
    }
    
    
    public double getMaxOfColorMap()
    {
        Element colorMapElem = (Element)((Element)((Element)((Element)((Element)((Element)document.getDocumentElement().getElementsByTagName("UserLayer").item(0)).getElementsByTagName("UserStyle").item(0)).getElementsByTagName("FeatureTypeStyle").item(0)).getElementsByTagName("Rule").item(0)).getElementsByTagName("RasterSymbolizer").item(0)).getElementsByTagName("ColorMap").item(0);
    	NodeList colorMapEntrys = colorMapElem.getElementsByTagName("*");
    	double maxValue = Double.parseDouble(((Element)colorMapEntrys.item(0)).getAttribute("quantity"));
    	for(int i = 1; i< colorMapEntrys.getLength(); i++)
    	{
    		if(Double.parseDouble(((Element)colorMapEntrys.item(i)).getAttribute("quantity")) > maxValue)
    			maxValue = Double.parseDouble(((Element)colorMapEntrys.item(i)).getAttribute("quantity"));
    		
    	}
    	return maxValue;
    }
    
    public String getMaxLabelOfColormap()
    {
        Element colorMapElem = (Element)((Element)((Element)((Element)((Element)((Element)document.getDocumentElement().getElementsByTagName("UserLayer").item(0)).getElementsByTagName("UserStyle").item(0)).getElementsByTagName("FeatureTypeStyle").item(0)).getElementsByTagName("Rule").item(0)).getElementsByTagName("RasterSymbolizer").item(0)).getElementsByTagName("ColorMap").item(0);
    	NodeList colorMapEntrys = colorMapElem.getElementsByTagName("*");
    	Element maxElem = (Element)colorMapEntrys.item(0);
    	for(int i = 1; i< colorMapEntrys.getLength(); i++)
    	{
    		if(Double.parseDouble(((Element)colorMapEntrys.item(i)).getAttribute("quantity")) > Double.parseDouble((maxElem).getAttribute("quantity")))
    			maxElem = (Element)colorMapEntrys.item(i);
    	}
    	return maxElem.getAttribute("label");
    }
    public String getMinLabelOfColormap()
    {
        Element colorMapElem = (Element)((Element)((Element)((Element)((Element)((Element)document.getDocumentElement().getElementsByTagName("UserLayer").item(0)).getElementsByTagName("UserStyle").item(0)).getElementsByTagName("FeatureTypeStyle").item(0)).getElementsByTagName("Rule").item(0)).getElementsByTagName("RasterSymbolizer").item(0)).getElementsByTagName("ColorMap").item(0);
    	NodeList colorMapEntrys = colorMapElem.getElementsByTagName("*");
    	Element minElem = (Element)colorMapEntrys.item(0);
    	for(int i = 1; i< colorMapEntrys.getLength(); i++)
    	{
    		if(Double.parseDouble(((Element)colorMapEntrys.item(i)).getAttribute("quantity")) < Double.parseDouble((minElem).getAttribute("quantity")))
    			minElem = (Element)colorMapEntrys.item(i);
    	}
    	return minElem.getAttribute("label");
    }
    /**
     * 
     * @return just the Name of each userLayer
     */
    public String[] getUserLayers() {
        NodeList userLayerElems = getUserLayerElements();
        String[] userLayers = new String[userLayerElems.getLength()];
        for(int i = 0; i<userLayerElems.getLength(); i++) {
            Element elem = (Element)userLayerElems.item(i);
            userLayers [i] = elem.getElementsByTagName("Name").item(0).getNodeValue();
        }
        return userLayers;
    }
    
    private NodeList getUserLayerElements() {
        return document.getDocumentElement().getElementsByTagName("UserLayer");
    }
    /**
     * 
     * @param name name of the UserLayer
     * @return
     */
    public String[] getStylesOfUserLayer(String name) {
        NodeList userLayers = getUserLayerElements();
        String[] userStyleNames = null;
        for(int i = 0; i<userLayers.getLength(); i++) {
            Element userLayerElem = (Element) userLayers.item(i);
            if(userLayerElem.getElementsByTagName("Name").item(0).getNodeValue().equals(name)) {
                NodeList userStyles = userLayerElem.getElementsByTagName("UserStyle");
                userStyleNames = new String[userStyles.getLength()];
                for(int j = 0; j < userStyles.getLength(); j++) {
                    Element userStyleElem = (Element) userStyles.item(j);
                    userStyleNames[j] = userStyleElem.getElementsByTagName("Name").item(0).getNodeValue();
                }
            }
        }
        return userStyleNames;
    }
    public String getTitleOfStyle(String layerName, String styleName) {
        NodeList userLayers = getUserLayerElements();
        for(int i = 0; i < userLayers.getLength(); i++) {
            Element userLayerElem = (Element) userLayers.item(i);
            if(userLayerElem.getElementsByTagName("Name").item(0).getNodeValue().equals(layerName)) {
                NodeList userStyles = userLayerElem.getElementsByTagName("UserStyle");
                for(int j = 0; j < userStyles.getLength(); j++) {
                    Element userStyleElem = (Element) userStyles.item(j);
                    if(userStyleElem.getElementsByTagName("Name").item(j).getNodeValue().equals(styleName))
                        return userStyleElem.getElementsByTagName("Title").item(0).getNodeValue();
                }
            }
        }
        return null;
        
    }
    public boolean containsUserLayer() {
        return document.getDocumentElement().getElementsByTagName("UserLayer") != null;
    }
    
    public boolean containsNamedLayers() {
        return document.getDocumentElement().getElementsByTagName("NamedLayer") != null;
    }
    
}
